
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yylval          parser_lval
#define yychar          parser_char
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.y"

/*
 * IDL Compiler
 *
 * Copyright 2002 Ove Kaaven
 * Copyright 2006-2008 Robert Shearman
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include "widl.h"
#include "utils.h"
#include "parser.h"
#include "header.h"
#include "typelib.h"
#include "typegen.h"
#include "expr.h"
#include "typetree.h"

static unsigned char pointer_default = RPC_FC_UP;

typedef struct list typelist_t;
struct typenode {
  type_t *type;
  struct list entry;
};

struct _import_t
{
  char *name;
  int import_performed;
};

typedef struct _decl_spec_t
{
  type_t *type;
  attr_list_t *attrs;
  enum storage_class stgclass;
} decl_spec_t;

typelist_t incomplete_types = LIST_INIT(incomplete_types);

static void fix_incomplete(void);
static void fix_incomplete_types(type_t *complete_type);

static str_list_t *append_str(str_list_t *list, char *str);
static attr_list_t *append_attr(attr_list_t *list, attr_t *attr);
static attr_list_t *append_attr_list(attr_list_t *new_list, attr_list_t *old_list);
static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right, attr_t *attr, enum storage_class stgclass);
static attr_t *make_attr(enum attr_type type);
static attr_t *make_attrv(enum attr_type type, unsigned int val);
static attr_t *make_attrp(enum attr_type type, void *val);
static expr_list_t *append_expr(expr_list_t *list, expr_t *expr);
static array_dims_t *append_array(array_dims_t *list, expr_t *expr);
static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, const declarator_t *decl, int top);
static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls);
static ifref_list_t *append_ifref(ifref_list_t *list, ifref_t *iface);
static ifref_t *make_ifref(type_t *iface);
static var_list_t *append_var_list(var_list_t *list, var_list_t *vars);
static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *p);
static declarator_t *make_declarator(var_t *var);
static type_t *make_safearray(type_t *type);
static typelib_t *make_library(const char *name, const attr_list_t *attrs);
static type_t *append_ptrchain_type(type_t *ptrchain, type_t *type);
static warning_list_t *append_warning(warning_list_t *, int);

static type_t *reg_typedefs(decl_spec_t *decl_spec, var_list_t *names, attr_list_t *attrs);
static type_t *find_type_or_error(const char *name, int t);
static type_t *find_type_or_error2(char *name, int t);

static var_t *reg_const(var_t *var);

static void push_namespace(const char *name);
static void pop_namespace(const char *name);

static char *gen_name(void);
static void check_arg_attrs(const var_t *arg);
static void check_statements(const statement_list_t *stmts, int is_inside_library);
static void check_all_user_types(const statement_list_t *stmts);
static attr_list_t *check_iface_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_function_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_typedef_attrs(attr_list_t *attrs);
static attr_list_t *check_enum_attrs(attr_list_t *attrs);
static attr_list_t *check_struct_attrs(attr_list_t *attrs);
static attr_list_t *check_union_attrs(attr_list_t *attrs);
static attr_list_t *check_field_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_library_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_dispiface_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_module_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_coclass_attrs(const char *name, attr_list_t *attrs);
const char *get_attr_display_name(enum attr_type type);
static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func);
static void check_def(const type_t *t);

static statement_t *make_statement(enum statement_type type);
static statement_t *make_statement_type_decl(type_t *type);
static statement_t *make_statement_reference(type_t *type);
static statement_t *make_statement_declaration(var_t *var);
static statement_t *make_statement_library(typelib_t *typelib);
static statement_t *make_statement_pragma(const char *str);
static statement_t *make_statement_cppquote(const char *str);
static statement_t *make_statement_importlib(const char *str);
static statement_t *make_statement_module(type_t *type);
static statement_t *make_statement_typedef(var_list_t *names);
static statement_t *make_statement_import(const char *str);
static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt);
static statement_list_t *append_statements(statement_list_t *, statement_list_t *);
static attr_list_t *append_attribs(attr_list_t *, attr_list_t *);

static struct namespace global_namespace = {
    NULL, NULL, LIST_INIT(global_namespace.entry), LIST_INIT(global_namespace.children)
};

static struct namespace *current_namespace = &global_namespace;



/* Line 189 of yacc.c  */
#line 220 "parser.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     aIDENTIFIER = 258,
     aPRAGMA = 259,
     aKNOWNTYPE = 260,
     aNUM = 261,
     aHEXNUM = 262,
     aDOUBLE = 263,
     aSTRING = 264,
     aWSTRING = 265,
     aSQSTRING = 266,
     aUUID = 267,
     aEOF = 268,
     SHL = 269,
     SHR = 270,
     MEMBERPTR = 271,
     EQUALITY = 272,
     INEQUALITY = 273,
     GREATEREQUAL = 274,
     LESSEQUAL = 275,
     LOGICALOR = 276,
     LOGICALAND = 277,
     ELLIPSIS = 278,
     tAGGREGATABLE = 279,
     tALLOCATE = 280,
     tANNOTATION = 281,
     tAPPOBJECT = 282,
     tASYNC = 283,
     tASYNCUUID = 284,
     tAUTOHANDLE = 285,
     tBINDABLE = 286,
     tBOOLEAN = 287,
     tBROADCAST = 288,
     tBYTE = 289,
     tBYTECOUNT = 290,
     tCALLAS = 291,
     tCALLBACK = 292,
     tCASE = 293,
     tCDECL = 294,
     tCHAR = 295,
     tCOCLASS = 296,
     tCODE = 297,
     tCOMMSTATUS = 298,
     tCONST = 299,
     tCONTEXTHANDLE = 300,
     tCONTEXTHANDLENOSERIALIZE = 301,
     tCONTEXTHANDLESERIALIZE = 302,
     tCONTROL = 303,
     tCPPQUOTE = 304,
     tDECODE = 305,
     tDEFAULT = 306,
     tDEFAULTBIND = 307,
     tDEFAULTCOLLELEM = 308,
     tDEFAULTVALUE = 309,
     tDEFAULTVTABLE = 310,
     tDISABLECONSISTENCYCHECK = 311,
     tDISPLAYBIND = 312,
     tDISPINTERFACE = 313,
     tDLLNAME = 314,
     tDOUBLE = 315,
     tDUAL = 316,
     tENABLEALLOCATE = 317,
     tENCODE = 318,
     tENDPOINT = 319,
     tENTRY = 320,
     tENUM = 321,
     tERRORSTATUST = 322,
     tEXPLICITHANDLE = 323,
     tEXTERN = 324,
     tFALSE = 325,
     tFASTCALL = 326,
     tFAULTSTATUS = 327,
     tFLOAT = 328,
     tFORCEALLOCATE = 329,
     tHANDLE = 330,
     tHANDLET = 331,
     tHELPCONTEXT = 332,
     tHELPFILE = 333,
     tHELPSTRING = 334,
     tHELPSTRINGCONTEXT = 335,
     tHELPSTRINGDLL = 336,
     tHIDDEN = 337,
     tHYPER = 338,
     tID = 339,
     tIDEMPOTENT = 340,
     tIGNORE = 341,
     tIIDIS = 342,
     tIMMEDIATEBIND = 343,
     tIMPLICITHANDLE = 344,
     tIMPORT = 345,
     tIMPORTLIB = 346,
     tIN = 347,
     tIN_LINE = 348,
     tINLINE = 349,
     tINPUTSYNC = 350,
     tINT = 351,
     tINT3264 = 352,
     tINT64 = 353,
     tINTERFACE = 354,
     tLCID = 355,
     tLENGTHIS = 356,
     tLIBRARY = 357,
     tLICENSED = 358,
     tLOCAL = 359,
     tLONG = 360,
     tMAYBE = 361,
     tMESSAGE = 362,
     tMETHODS = 363,
     tMODULE = 364,
     tNAMESPACE = 365,
     tNOCODE = 366,
     tNONBROWSABLE = 367,
     tNONCREATABLE = 368,
     tNONEXTENSIBLE = 369,
     tNOTIFY = 370,
     tNOTIFYFLAG = 371,
     tNULL = 372,
     tOBJECT = 373,
     tODL = 374,
     tOLEAUTOMATION = 375,
     tOPTIMIZE = 376,
     tOPTIONAL = 377,
     tOUT = 378,
     tPARTIALIGNORE = 379,
     tPASCAL = 380,
     tPOINTERDEFAULT = 381,
     tPRAGMA_WARNING = 382,
     tPROGID = 383,
     tPROPERTIES = 384,
     tPROPGET = 385,
     tPROPPUT = 386,
     tPROPPUTREF = 387,
     tPROXY = 388,
     tPTR = 389,
     tPUBLIC = 390,
     tRANGE = 391,
     tREADONLY = 392,
     tREF = 393,
     tREGISTER = 394,
     tREPRESENTAS = 395,
     tREQUESTEDIT = 396,
     tRESTRICTED = 397,
     tRETVAL = 398,
     tSAFEARRAY = 399,
     tSHORT = 400,
     tSIGNED = 401,
     tSIZEIS = 402,
     tSIZEOF = 403,
     tSMALL = 404,
     tSOURCE = 405,
     tSTATIC = 406,
     tSTDCALL = 407,
     tSTRICTCONTEXTHANDLE = 408,
     tSTRING = 409,
     tSTRUCT = 410,
     tSWITCH = 411,
     tSWITCHIS = 412,
     tSWITCHTYPE = 413,
     tTHREADING = 414,
     tTRANSMITAS = 415,
     tTRUE = 416,
     tTYPEDEF = 417,
     tUIDEFAULT = 418,
     tUNION = 419,
     tUNIQUE = 420,
     tUNSIGNED = 421,
     tUSESGETLASTERROR = 422,
     tUSERMARSHAL = 423,
     tUUID = 424,
     tV1ENUM = 425,
     tVARARG = 426,
     tVERSION = 427,
     tVIPROGID = 428,
     tVOID = 429,
     tWCHAR = 430,
     tWIREMARSHAL = 431,
     tAPARTMENT = 432,
     tNEUTRAL = 433,
     tSINGLE = 434,
     tFREE = 435,
     tBOTH = 436,
     ADDRESSOF = 437,
     NEG = 438,
     POS = 439,
     PPTR = 440,
     CAST = 441
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 138 "parser.y"

	attr_t *attr;
	attr_list_t *attr_list;
	str_list_t *str_list;
	expr_t *expr;
	expr_list_t *expr_list;
	array_dims_t *array_dims;
	type_t *type;
	var_t *var;
	var_list_t *var_list;
	declarator_t *declarator;
	declarator_list_t *declarator_list;
	statement_t *statement;
	statement_list_t *stmt_list;
	warning_t *warning;
	warning_list_t *warning_list;
	ifref_t *ifref;
	ifref_list_t *ifref_list;
	char *str;
	UUID *uuid;
	unsigned int num;
	double dbl;
	interface_info_t ifinfo;
	typelib_t *typelib;
	struct _import_t *import;
	struct _decl_spec_t *declspec;
	enum storage_class stgclass;



/* Line 214 of yacc.c  */
#line 473 "parser.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 485 "parser.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2995

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  211
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  105
/* YYNRULES -- Number of rules.  */
#define YYNRULES  394
/* YYNRULES -- Number of states.  */
#define YYNSTATES  691

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   441

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   195,     2,     2,     2,   194,   187,     2,
     208,   209,   192,   191,   182,   190,   202,   193,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   184,   207,
     188,   210,   189,   183,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   203,     2,   204,   186,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   205,   185,   206,   196,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   197,   198,   199,
     200,   201
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,     7,    14,    17,    20,    24,
      27,    30,    33,    36,    37,    40,    41,    48,    51,    55,
      58,    61,    64,    67,    70,    71,    74,    75,    77,    79,
      82,    85,    87,    90,    92,    94,   101,   103,   106,   108,
     111,   113,   116,   118,   121,   124,   127,   130,   135,   139,
     143,   149,   152,   155,   159,   164,   165,   167,   169,   173,
     175,   179,   183,   186,   190,   194,   197,   198,   200,   204,
     206,   210,   215,   217,   221,   222,   224,   229,   231,   233,
     235,   237,   239,   244,   249,   251,   253,   255,   257,   259,
     261,   263,   265,   267,   269,   274,   276,   278,   280,   285,
     287,   289,   291,   296,   301,   303,   305,   307,   309,   314,
     319,   324,   329,   334,   336,   341,   343,   345,   350,   352,
     357,   359,   361,   366,   371,   373,   375,   377,   379,   381,
     383,   385,   387,   389,   391,   393,   395,   397,   399,   404,
     406,   408,   410,   415,   420,   422,   424,   426,   428,   430,
     437,   439,   444,   446,   448,   450,   455,   457,   459,   461,
     466,   471,   476,   481,   483,   485,   490,   495,   500,   502,
     504,   509,   514,   519,   521,   523,   525,   527,   529,   531,
     533,   534,   537,   542,   546,   547,   550,   552,   554,   558,
     562,   564,   570,   572,   576,   577,   579,   581,   583,   585,
     587,   589,   591,   593,   595,   597,   599,   605,   609,   613,
     617,   621,   625,   629,   633,   637,   641,   645,   649,   653,
     657,   661,   665,   669,   673,   677,   680,   683,   686,   689,
     692,   695,   699,   703,   709,   715,   720,   724,   726,   730,
     732,   734,   735,   738,   743,   747,   750,   753,   754,   757,
     760,   762,   766,   769,   771,   775,   778,   779,   781,   782,
     784,   786,   788,   790,   792,   794,   796,   799,   802,   804,
     806,   808,   810,   812,   814,   815,   817,   819,   822,   824,
     827,   830,   832,   834,   836,   839,   842,   845,   851,   854,
     855,   858,   861,   864,   867,   870,   873,   877,   880,   884,
     890,   896,   897,   900,   903,   906,   909,   916,   925,   928,
     931,   934,   937,   940,   943,   949,   951,   953,   955,   957,
     959,   960,   963,   966,   970,   971,   973,   976,   979,   982,
     986,   989,   991,   993,   997,  1000,  1005,  1009,  1012,  1014,
    1018,  1021,  1022,  1024,  1028,  1031,  1033,  1037,  1042,  1046,
    1049,  1051,  1055,  1058,  1059,  1061,  1063,  1067,  1070,  1072,
    1076,  1081,  1083,  1087,  1088,  1091,  1094,  1096,  1100,  1102,
    1106,  1108,  1110,  1112,  1114,  1116,  1118,  1120,  1122,  1128,
    1130,  1132,  1134,  1136,  1139,  1141,  1144,  1146,  1149,  1154,
    1160,  1166,  1177,  1179,  1183
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     212,     0,    -1,   213,    -1,    -1,    -1,   213,   271,   205,
     214,   213,   206,    -1,   213,   283,    -1,   213,   282,    -1,
     213,   268,   207,    -1,   213,   270,    -1,   213,   286,    -1,
     213,   229,    -1,   213,   219,    -1,    -1,   215,   283,    -1,
      -1,   215,   271,   205,   216,   215,   206,    -1,   215,   282,
      -1,   215,   268,   207,    -1,   215,   270,    -1,   215,   286,
      -1,   215,   219,    -1,   215,   226,    -1,   215,   229,    -1,
      -1,   217,   219,    -1,    -1,   207,    -1,   223,    -1,   222,
     207,    -1,   261,   207,    -1,   225,    -1,   313,   207,    -1,
       4,    -1,   220,    -1,   127,   208,     3,   184,   221,   209,
      -1,     6,    -1,   221,     6,    -1,   247,    -1,    66,     3,
      -1,   311,    -1,   155,     3,    -1,   314,    -1,   164,     3,
      -1,   236,   247,    -1,   236,   311,    -1,   236,   314,    -1,
      49,   208,     9,   209,    -1,    90,     9,   207,    -1,   224,
     215,    13,    -1,    91,   208,     9,   209,   218,    -1,   102,
       3,    -1,   102,     5,    -1,   236,   227,   205,    -1,   228,
     215,   206,   218,    -1,    -1,   232,    -1,   233,    -1,   231,
     182,   233,    -1,   231,    -1,   231,   182,    23,    -1,   236,
     291,   302,    -1,   291,   302,    -1,   203,   250,   204,    -1,
     203,   192,   204,    -1,   203,   204,    -1,    -1,   236,    -1,
     203,   237,   204,    -1,   239,    -1,   237,   182,   239,    -1,
     237,   204,   203,   239,    -1,     9,    -1,   238,   182,     9,
      -1,    -1,    24,    -1,    26,   208,     9,   209,    -1,    27,
      -1,    28,    -1,    30,    -1,    31,    -1,    33,    -1,    36,
     208,   264,   209,    -1,    38,   208,   251,   209,    -1,    42,
      -1,    43,    -1,    45,    -1,    46,    -1,    47,    -1,    48,
      -1,    50,    -1,    51,    -1,    52,    -1,    53,    -1,    54,
     208,   253,   209,    -1,    55,    -1,    56,    -1,    57,    -1,
      59,   208,     9,   209,    -1,    61,    -1,    62,    -1,    63,
      -1,    64,   208,   238,   209,    -1,    65,   208,   253,   209,
      -1,    68,    -1,    72,    -1,    74,    -1,    75,    -1,    77,
     208,   252,   209,    -1,    78,   208,     9,   209,    -1,    79,
     208,     9,   209,    -1,    80,   208,   252,   209,    -1,    81,
     208,     9,   209,    -1,    82,    -1,    84,   208,   252,   209,
      -1,    85,    -1,    86,    -1,    87,   208,   250,   209,    -1,
      88,    -1,    89,   208,   233,   209,    -1,    92,    -1,    95,
      -1,   101,   208,   248,   209,    -1,   100,   208,   252,   209,
      -1,   100,    -1,   103,    -1,   104,    -1,   106,    -1,   107,
      -1,   111,    -1,   112,    -1,   113,    -1,   114,    -1,   115,
      -1,   116,    -1,   118,    -1,   119,    -1,   120,    -1,   121,
     208,     9,   209,    -1,   122,    -1,   123,    -1,   124,    -1,
     126,   208,   310,   209,    -1,   128,   208,     9,   209,    -1,
     130,    -1,   131,    -1,   132,    -1,   133,    -1,   135,    -1,
     136,   208,   252,   182,   252,   209,    -1,   137,    -1,   140,
     208,   312,   209,    -1,   141,    -1,   142,    -1,   143,    -1,
     147,   208,   248,   209,    -1,   150,    -1,   153,    -1,   154,
      -1,   157,   208,   250,   209,    -1,   158,   208,   312,   209,
      -1,   160,   208,   312,   209,    -1,   159,   208,   309,   209,
      -1,   163,    -1,   167,    -1,   168,   208,   312,   209,    -1,
     169,   208,   240,   209,    -1,    29,   208,   240,   209,    -1,
     170,    -1,   171,    -1,   172,   208,   315,   209,    -1,   173,
     208,     9,   209,    -1,   176,   208,   312,   209,    -1,   310,
      -1,    12,    -1,     9,    -1,    39,    -1,    71,    -1,   125,
      -1,   152,    -1,    -1,   242,   243,    -1,    38,   252,   184,
     258,    -1,    51,   184,   258,    -1,    -1,   245,   182,    -1,
     245,    -1,   246,    -1,   245,   182,   246,    -1,   264,   210,
     252,    -1,   264,    -1,    66,   263,   205,   244,   206,    -1,
     249,    -1,   248,   182,   249,    -1,    -1,   250,    -1,     6,
      -1,     7,    -1,     8,    -1,    70,    -1,   117,    -1,   161,
      -1,     9,    -1,    10,    -1,    11,    -1,     3,    -1,   250,
     183,   250,   184,   250,    -1,   250,    21,   250,    -1,   250,
      22,   250,    -1,   250,   185,   250,    -1,   250,   186,   250,
      -1,   250,   187,   250,    -1,   250,    17,   250,    -1,   250,
      18,   250,    -1,   250,   189,   250,    -1,   250,   188,   250,
      -1,   250,    19,   250,    -1,   250,    20,   250,    -1,   250,
      14,   250,    -1,   250,    15,   250,    -1,   250,   191,   250,
      -1,   250,   190,   250,    -1,   250,   194,   250,    -1,   250,
     192,   250,    -1,   250,   193,   250,    -1,   195,   250,    -1,
     196,   250,    -1,   191,   250,    -1,   190,   250,    -1,   187,
     250,    -1,   192,   250,    -1,   250,    16,     3,    -1,   250,
     202,     3,    -1,   208,   291,   298,   209,   250,    -1,   148,
     208,   291,   298,   209,    -1,   250,   203,   250,   204,    -1,
     208,   250,   209,    -1,   252,    -1,   251,   182,   252,    -1,
     250,    -1,   250,    -1,    -1,   254,   255,    -1,   235,   291,
     307,   207,    -1,   235,   314,   207,    -1,   259,   207,    -1,
     236,   207,    -1,    -1,   257,   256,    -1,   259,   207,    -1,
     207,    -1,   235,   291,   294,    -1,   235,   311,    -1,   261,
      -1,   236,   291,   308,    -1,   291,   308,    -1,    -1,   264,
      -1,    -1,     3,    -1,     5,    -1,     3,    -1,     5,    -1,
      34,    -1,   175,    -1,   267,    -1,   146,   267,    -1,   166,
     267,    -1,   166,    -1,    73,    -1,    60,    -1,    32,    -1,
      67,    -1,    76,    -1,    -1,    96,    -1,    96,    -1,   145,
     266,    -1,   149,    -1,   105,   266,    -1,    83,   266,    -1,
      98,    -1,    40,    -1,    97,    -1,    41,     3,    -1,    41,
       5,    -1,   236,   268,    -1,   269,   205,   272,   206,   218,
      -1,   110,     3,    -1,    -1,   272,   273,    -1,   235,   283,
      -1,    58,     3,    -1,    58,     5,    -1,   236,   274,    -1,
     129,   184,    -1,   276,   259,   207,    -1,   108,   184,    -1,
     277,   260,   207,    -1,   275,   205,   276,   277,   206,    -1,
     275,   205,   280,   207,   206,    -1,    -1,   184,     5,    -1,
      99,     3,    -1,    99,     5,    -1,   236,   280,    -1,   281,
     279,   205,   217,   206,   218,    -1,   281,   184,     3,   205,
     225,   217,   206,   218,    -1,   278,   218,    -1,   280,   207,
      -1,   274,   207,    -1,   109,     3,    -1,   109,     5,    -1,
     236,   284,    -1,   285,   205,   217,   206,   218,    -1,    69,
      -1,   151,    -1,   139,    -1,    94,    -1,    44,    -1,    -1,
     290,   289,    -1,   312,   292,    -1,   293,   312,   292,    -1,
      -1,   293,    -1,   289,   292,    -1,   288,   292,    -1,   287,
     292,    -1,   192,   290,   294,    -1,   241,   294,    -1,   295,
      -1,   264,    -1,   208,   294,   209,    -1,   295,   234,    -1,
     295,   208,   230,   209,    -1,   192,   290,   298,    -1,   241,
     298,    -1,   299,    -1,   192,   290,   302,    -1,   241,   302,
      -1,    -1,   296,    -1,   208,   297,   209,    -1,   299,   234,
      -1,   234,    -1,   208,   230,   209,    -1,   299,   208,   230,
     209,    -1,   192,   290,   302,    -1,   241,   302,    -1,   303,
      -1,   192,   290,   302,    -1,   241,   302,    -1,    -1,   300,
      -1,   264,    -1,   208,   301,   209,    -1,   303,   234,    -1,
     234,    -1,   208,   230,   209,    -1,   303,   208,   230,   209,
      -1,   294,    -1,   304,   182,   294,    -1,    -1,   184,   253,
      -1,   300,   305,    -1,   306,    -1,   307,   182,   306,    -1,
     294,    -1,   294,   210,   253,    -1,   177,    -1,   178,    -1,
     179,    -1,   180,    -1,   181,    -1,   138,    -1,   165,    -1,
     134,    -1,   155,   263,   205,   254,   206,    -1,   174,    -1,
       5,    -1,   265,    -1,   247,    -1,    66,     3,    -1,   311,
      -1,   155,     3,    -1,   314,    -1,   164,     3,    -1,   144,
     208,   312,   209,    -1,   235,   162,   235,   291,   304,    -1,
     164,   263,   205,   257,   206,    -1,   164,   263,   156,   208,
     259,   209,   262,   205,   242,   206,    -1,     6,    -1,     6,
     202,     6,    -1,     7,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   321,   321,   335,   336,   336,   338,   339,   340,   343,
     346,   347,   348,   351,   352,   353,   353,   355,   356,   357,
     360,   361,   362,   363,   366,   367,   370,   371,   375,   376,
     377,   378,   379,   380,   381,   384,   395,   396,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   411,   413,   421,
     427,   431,   432,   434,   438,   445,   446,   449,   450,   453,
     454,   458,   463,   470,   474,   475,   478,   479,   483,   486,
     487,   488,   491,   492,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   601,   602,   607,   608,   609,   610,
     613,   614,   617,   621,   627,   628,   629,   632,   636,   648,
     652,   657,   660,   661,   664,   665,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   707,   709,   710,   713,   714,   717,
     723,   729,   730,   733,   738,   745,   746,   749,   750,   754,
     755,   758,   762,   768,   776,   780,   785,   786,   789,   790,
     791,   794,   796,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   808,   809,   812,   813,   816,   817,   818,   819,
     820,   821,   822,   823,   826,   827,   835,   841,   845,   848,
     849,   853,   856,   857,   860,   869,   870,   873,   874,   877,
     883,   889,   890,   893,   894,   897,   907,   916,   922,   926,
     927,   930,   931,   934,   939,   946,   947,   948,   952,   956,
     959,   960,   963,   964,   968,   969,   973,   974,   975,   979,
     981,   983,   987,   988,   989,   990,   998,  1000,  1002,  1007,
    1009,  1014,  1015,  1020,  1021,  1022,  1023,  1028,  1037,  1039,
    1040,  1045,  1047,  1051,  1052,  1059,  1060,  1061,  1062,  1063,
    1068,  1076,  1077,  1080,  1081,  1084,  1091,  1092,  1097,  1098,
    1102,  1103,  1104,  1105,  1106,  1110,  1111,  1112,  1115,  1118,
    1119,  1120,  1121,  1122,  1123,  1124,  1125,  1126,  1127,  1130,
    1137,  1139,  1145,  1146,  1147
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "aIDENTIFIER", "aPRAGMA", "aKNOWNTYPE",
  "aNUM", "aHEXNUM", "aDOUBLE", "aSTRING", "aWSTRING", "aSQSTRING",
  "aUUID", "aEOF", "SHL", "SHR", "MEMBERPTR", "EQUALITY", "INEQUALITY",
  "GREATEREQUAL", "LESSEQUAL", "LOGICALOR", "LOGICALAND", "ELLIPSIS",
  "tAGGREGATABLE", "tALLOCATE", "tANNOTATION", "tAPPOBJECT", "tASYNC",
  "tASYNCUUID", "tAUTOHANDLE", "tBINDABLE", "tBOOLEAN", "tBROADCAST",
  "tBYTE", "tBYTECOUNT", "tCALLAS", "tCALLBACK", "tCASE", "tCDECL",
  "tCHAR", "tCOCLASS", "tCODE", "tCOMMSTATUS", "tCONST", "tCONTEXTHANDLE",
  "tCONTEXTHANDLENOSERIALIZE", "tCONTEXTHANDLESERIALIZE", "tCONTROL",
  "tCPPQUOTE", "tDECODE", "tDEFAULT", "tDEFAULTBIND", "tDEFAULTCOLLELEM",
  "tDEFAULTVALUE", "tDEFAULTVTABLE", "tDISABLECONSISTENCYCHECK",
  "tDISPLAYBIND", "tDISPINTERFACE", "tDLLNAME", "tDOUBLE", "tDUAL",
  "tENABLEALLOCATE", "tENCODE", "tENDPOINT", "tENTRY", "tENUM",
  "tERRORSTATUST", "tEXPLICITHANDLE", "tEXTERN", "tFALSE", "tFASTCALL",
  "tFAULTSTATUS", "tFLOAT", "tFORCEALLOCATE", "tHANDLE", "tHANDLET",
  "tHELPCONTEXT", "tHELPFILE", "tHELPSTRING", "tHELPSTRINGCONTEXT",
  "tHELPSTRINGDLL", "tHIDDEN", "tHYPER", "tID", "tIDEMPOTENT", "tIGNORE",
  "tIIDIS", "tIMMEDIATEBIND", "tIMPLICITHANDLE", "tIMPORT", "tIMPORTLIB",
  "tIN", "tIN_LINE", "tINLINE", "tINPUTSYNC", "tINT", "tINT3264", "tINT64",
  "tINTERFACE", "tLCID", "tLENGTHIS", "tLIBRARY", "tLICENSED", "tLOCAL",
  "tLONG", "tMAYBE", "tMESSAGE", "tMETHODS", "tMODULE", "tNAMESPACE",
  "tNOCODE", "tNONBROWSABLE", "tNONCREATABLE", "tNONEXTENSIBLE", "tNOTIFY",
  "tNOTIFYFLAG", "tNULL", "tOBJECT", "tODL", "tOLEAUTOMATION", "tOPTIMIZE",
  "tOPTIONAL", "tOUT", "tPARTIALIGNORE", "tPASCAL", "tPOINTERDEFAULT",
  "tPRAGMA_WARNING", "tPROGID", "tPROPERTIES", "tPROPGET", "tPROPPUT",
  "tPROPPUTREF", "tPROXY", "tPTR", "tPUBLIC", "tRANGE", "tREADONLY",
  "tREF", "tREGISTER", "tREPRESENTAS", "tREQUESTEDIT", "tRESTRICTED",
  "tRETVAL", "tSAFEARRAY", "tSHORT", "tSIGNED", "tSIZEIS", "tSIZEOF",
  "tSMALL", "tSOURCE", "tSTATIC", "tSTDCALL", "tSTRICTCONTEXTHANDLE",
  "tSTRING", "tSTRUCT", "tSWITCH", "tSWITCHIS", "tSWITCHTYPE",
  "tTHREADING", "tTRANSMITAS", "tTRUE", "tTYPEDEF", "tUIDEFAULT", "tUNION",
  "tUNIQUE", "tUNSIGNED", "tUSESGETLASTERROR", "tUSERMARSHAL", "tUUID",
  "tV1ENUM", "tVARARG", "tVERSION", "tVIPROGID", "tVOID", "tWCHAR",
  "tWIREMARSHAL", "tAPARTMENT", "tNEUTRAL", "tSINGLE", "tFREE", "tBOTH",
  "','", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'-'", "'+'",
  "'*'", "'/'", "'%'", "'!'", "'~'", "ADDRESSOF", "NEG", "POS", "PPTR",
  "CAST", "'.'", "'['", "']'", "'{'", "'}'", "';'", "'('", "')'", "'='",
  "$accept", "input", "gbl_statements", "$@1", "imp_statements", "$@2",
  "int_statements", "semicolon_opt", "statement", "pragma_warning",
  "warnings", "typedecl", "cppquote", "import_start", "import",
  "importlib", "libraryhdr", "library_start", "librarydef", "m_args",
  "arg_list", "args", "arg", "array", "m_attributes", "attributes",
  "attrib_list", "str_list", "attribute", "uuid_string", "callconv",
  "cases", "case", "enums", "enum_list", "enum", "enumdef", "m_exprs",
  "m_expr", "expr", "expr_list_int_const", "expr_int_const", "expr_const",
  "fields", "field", "ne_union_field", "ne_union_fields", "union_field",
  "s_field", "funcdef", "declaration", "m_ident", "t_ident", "ident",
  "base_type", "m_int", "int_std", "coclass", "coclasshdr", "coclassdef",
  "namespacedef", "coclass_ints", "coclass_int", "dispinterface",
  "dispinterfacehdr", "dispint_props", "dispint_meths", "dispinterfacedef",
  "inherit", "interface", "interfacehdr", "interfacedef", "interfacedec",
  "module", "modulehdr", "moduledef", "storage_cls_spec",
  "function_specifier", "type_qualifier", "m_type_qual_list", "decl_spec",
  "m_decl_spec_no_type", "decl_spec_no_type", "declarator",
  "direct_declarator", "abstract_declarator",
  "abstract_declarator_no_direct", "m_abstract_declarator",
  "abstract_direct_declarator", "any_declarator",
  "any_declarator_no_direct", "m_any_declarator", "any_direct_declarator",
  "declarator_list", "m_bitfield", "struct_declarator",
  "struct_declarator_list", "init_declarator", "threading_type",
  "pointer_type", "structdef", "type", "typedef", "uniondef", "version", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    44,    63,    58,   124,    94,    38,    60,    62,
      45,    43,    42,    47,    37,    33,   126,   437,   438,   439,
     440,   441,    46,    91,    93,   123,   125,    59,    40,    41,
      61
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   211,   212,   213,   214,   213,   213,   213,   213,   213,
     213,   213,   213,   215,   215,   216,   215,   215,   215,   215,
     215,   215,   215,   215,   217,   217,   218,   218,   219,   219,
     219,   219,   219,   219,   219,   220,   221,   221,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   223,   224,   225,
     226,   227,   227,   228,   229,   230,   230,   231,   231,   232,
     232,   233,   233,   234,   234,   234,   235,   235,   236,   237,
     237,   237,   238,   238,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   239,   240,   240,   241,   241,   241,   241,
     242,   242,   243,   243,   244,   244,   244,   245,   245,   246,
     246,   247,   248,   248,   249,   249,   250,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   251,   251,   252,
     253,   254,   254,   255,   255,   256,   256,   257,   257,   258,
     258,   259,   259,   260,   261,   261,   262,   262,   263,   263,
     263,   264,   264,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   266,   266,   267,   267,   267,   267,
     267,   267,   267,   267,   268,   268,   269,   270,   271,   272,
     272,   273,   274,   274,   275,   276,   276,   277,   277,   278,
     278,   279,   279,   280,   280,   281,   282,   282,   282,   283,
     283,   284,   284,   285,   286,   287,   287,   287,   288,   289,
     290,   290,   291,   291,   292,   292,   293,   293,   293,   294,
     294,   294,   295,   295,   295,   295,   296,   296,   296,   297,
     297,   298,   298,   299,   299,   299,   299,   299,   300,   300,
     300,   301,   301,   302,   302,   303,   303,   303,   303,   303,
     303,   304,   304,   305,   305,   306,   307,   307,   308,   308,
     309,   309,   309,   309,   309,   310,   310,   310,   311,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   313,
     314,   314,   315,   315,   315
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     0,     6,     2,     2,     3,     2,
       2,     2,     2,     0,     2,     0,     6,     2,     3,     2,
       2,     2,     2,     2,     0,     2,     0,     1,     1,     2,
       2,     1,     2,     1,     1,     6,     1,     2,     1,     2,
       1,     2,     1,     2,     2,     2,     2,     4,     3,     3,
       5,     2,     2,     3,     4,     0,     1,     1,     3,     1,
       3,     3,     2,     3,     3,     2,     0,     1,     3,     1,
       3,     4,     1,     3,     0,     1,     4,     1,     1,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     1,     1,     4,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     4,     4,
       4,     4,     4,     1,     4,     1,     1,     4,     1,     4,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     6,
       1,     4,     1,     1,     1,     4,     1,     1,     1,     4,
       4,     4,     4,     1,     1,     4,     4,     4,     1,     1,
       4,     4,     4,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     4,     3,     0,     2,     1,     1,     3,     3,
       1,     5,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     5,     5,     4,     3,     1,     3,     1,
       1,     0,     2,     4,     3,     2,     2,     0,     2,     2,
       1,     3,     2,     1,     3,     2,     0,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     2,     1,     2,
       2,     1,     1,     1,     2,     2,     2,     5,     2,     0,
       2,     2,     2,     2,     2,     2,     3,     2,     3,     5,
       5,     0,     2,     2,     2,     2,     6,     8,     2,     2,
       2,     2,     2,     2,     5,     1,     1,     1,     1,     1,
       0,     2,     2,     3,     0,     1,     2,     2,     2,     3,
       2,     1,     1,     3,     2,     4,     3,     2,     1,     3,
       2,     0,     1,     3,     2,     1,     3,     4,     3,     2,
       1,     3,     2,     0,     1,     1,     3,     2,     1,     3,
       4,     1,     3,     0,     2,     2,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     1,
       1,     1,     1,     2,     1,     2,     1,     2,     4,     5,
       5,    10,     1,     3,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       3,     0,     2,     1,    33,   380,   271,   263,   282,     0,
     319,     0,     0,   270,   258,   272,   315,   269,   273,   274,
       0,   318,   276,   283,   281,     0,   274,     0,     0,   317,
       0,   274,     0,   278,   316,   258,   258,   268,   379,   264,
      74,    12,    34,     0,    28,    13,    31,    13,    11,     0,
      67,   382,     0,   381,   265,     0,     0,     9,     0,     0,
       0,    26,     0,   301,     7,     6,     0,    10,   324,   324,
     324,     0,     0,   384,   324,     0,   386,   284,   285,     0,
     292,   293,   383,   260,     0,   275,   280,     0,   303,   304,
     279,   288,     0,     0,   277,   266,   385,     0,   387,     0,
     267,    75,     0,    77,    78,     0,    79,    80,    81,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,     0,    95,    96,    97,     0,    99,   100,   101,     0,
       0,   104,   105,   106,   107,     0,     0,     0,     0,     0,
     113,     0,   115,   116,     0,   118,     0,   120,   121,   124,
       0,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,     0,   139,   140,   141,     0,     0,
     144,   145,   146,   147,   377,   148,     0,   150,   375,     0,
     152,   153,   154,     0,   156,   157,   158,     0,     0,     0,
       0,   163,   376,   164,     0,     0,   168,   169,     0,     0,
       0,     0,    69,   173,    29,    66,    66,    66,   258,     0,
       0,   258,   258,     0,   382,   286,   294,   305,   313,     0,
     384,   386,    30,     8,   289,     4,   310,     0,    27,   308,
     309,     0,     0,    24,   328,   325,   327,   326,   261,   262,
     176,   177,   178,   179,   320,     0,     0,   332,   368,   331,
     255,   382,   384,   324,   386,   322,    32,     0,   184,    48,
       0,     0,   241,     0,   247,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   194,     0,     0,     0,     0,     0,   194,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    74,    68,
      49,     0,    21,    22,    23,     0,    19,     0,    17,    14,
      20,    26,     0,    67,   383,    51,    52,   311,   312,   385,
     387,    53,   254,    66,     3,     0,    66,     0,     0,   302,
      24,    66,     0,     0,   330,     0,     0,    55,   334,   323,
      47,     0,   186,   187,   190,     0,   388,    66,    66,    66,
       0,   175,   174,     0,     0,   205,   196,   197,   198,   202,
     203,   204,   199,   200,     0,   201,     0,     0,     0,     0,
       0,     0,     0,   239,     0,   237,   240,     0,     0,    72,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   353,     0,     0,   192,   195,     0,     0,     0,     0,
       0,     0,     0,     0,   370,   371,   372,   373,   374,     0,
       0,     0,     0,   392,   394,     0,     0,     0,    70,    74,
       0,    18,    15,    54,     0,    26,     0,   290,    66,   295,
       0,     0,     0,     0,     0,     0,    66,    26,    25,    67,
     321,   329,   333,   369,     0,    65,     0,     0,    59,    56,
      57,   191,   185,     0,    36,     0,   378,     0,   242,     0,
     390,    67,   248,     0,    76,   167,    82,     0,   229,   228,
     227,   230,   225,   226,     0,   341,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
      94,    98,     0,   102,   103,   108,   109,   110,   111,   112,
     114,   117,   119,   353,   320,    55,   358,   353,   355,   354,
      62,   350,   123,   194,   122,   138,   142,   143,     0,   151,
     155,   159,   160,   162,   161,   165,   166,     0,   170,   171,
     172,    71,     0,    13,   361,   389,   287,   291,     5,   297,
       0,   384,   296,   299,     0,     0,   253,   300,    24,    26,
     314,    64,    63,   335,     0,   188,   189,    37,    35,     0,
     386,   256,   246,   245,   341,   236,   320,    55,   345,   341,
     342,     0,   338,   218,   219,   231,   212,   213,   216,   217,
     207,   208,     0,   209,   210,   211,   215,   214,   221,   220,
     223,   224,   222,   232,     0,   238,    73,    61,   353,   320,
       0,   353,     0,   349,    55,   357,   193,     0,   393,    26,
      66,     0,   251,   298,    66,   306,    60,    58,   363,   366,
       0,   244,     0,   257,     0,   341,   320,     0,   353,     0,
     337,     0,    55,   344,     0,   235,   348,   353,   359,   352,
     356,     0,   149,    50,    16,   362,    26,     0,   365,     0,
     243,   180,   234,   336,   353,   346,   340,   343,   233,     0,
     206,   351,   360,   307,   364,   367,     0,   339,   347,     0,
       0,   391,   181,     0,    66,    66,   250,   183,     0,   182,
     249
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,   324,   205,   543,   331,   229,   302,    42,
     455,    43,    44,    45,    46,   303,   213,    47,   304,   447,
     448,   449,   450,   516,    49,   313,   201,   380,   202,   353,
     517,   676,   682,   341,   342,   343,   251,   393,   394,   373,
     374,   375,   377,   347,   458,   462,   349,   687,   688,   555,
      52,   632,    84,   518,    53,    86,    54,   305,    56,   306,
     307,   323,   427,    59,    60,   326,   433,    61,   232,    62,
      63,   308,   309,   218,    66,   310,    68,    69,    70,   332,
      71,   234,    72,   248,   249,   580,   639,   581,   582,   519,
     612,   520,   521,   545,   658,   629,   630,   250,   409,   203,
     252,    74,    75,   254,   415
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -521
static const yytype_int16 yypact[] =
{
    -521,    89,  1646,  -521,  -521,  -521,  -521,  -521,  -521,   156,
    -521,  -136,   172,  -521,   181,  -521,  -521,  -521,  -521,    -6,
      87,  -521,  -521,  -521,  -521,   218,    -6,   105,   -99,  -521,
     -75,    -6,   384,  -521,  -521,   223,   255,   384,  -521,  -521,
    2819,  -521,  -521,   -39,  -521,  -521,  -521,  -521,  -521,    25,
    2519,   -19,   -15,  -521,  -521,   -11,     6,  -521,    24,     3,
      27,    15,    29,    21,  -521,  -521,    66,  -521,    44,    44,
      44,   162,  2667,    79,    44,   106,   109,  -521,  -521,   208,
    -521,  -521,    94,  -521,    74,  -521,  -521,   119,  -521,  -521,
    -521,  -521,   279,  2667,  -521,  -521,    97,   107,  -127,  -120,
    -521,  -521,   122,  -521,  -521,   125,  -521,  -521,  -521,   126,
     131,  -521,  -521,  -521,  -521,  -521,  -521,  -521,  -521,  -521,
    -521,   155,  -521,  -521,  -521,   160,  -521,  -521,  -521,   161,
     173,  -521,  -521,  -521,  -521,   179,   180,   183,   184,   192,
    -521,   193,  -521,  -521,   195,  -521,   196,  -521,  -521,   197,
     205,  -521,  -521,  -521,  -521,  -521,  -521,  -521,  -521,  -521,
    -521,  -521,  -521,  -521,   211,  -521,  -521,  -521,   212,   213,
    -521,  -521,  -521,  -521,  -521,  -521,   214,  -521,  -521,   215,
    -521,  -521,  -521,   217,  -521,  -521,  -521,   222,   246,   247,
     251,  -521,  -521,  -521,   252,   260,  -521,  -521,   261,   263,
     264,  -121,  -521,  -521,  -521,  1528,   791,   177,   319,   322,
     337,   343,   347,   207,   182,  -521,  -521,  -521,  -521,   162,
     209,   268,  -521,  -521,  -521,  -521,  -521,   -55,  -521,  -521,
    -521,   350,   271,  -521,  -521,  -521,  -521,  -521,  -521,  -521,
    -521,  -521,  -521,  -521,  -521,   162,   162,  -521,   267,   -96,
    -521,  -521,  -521,    44,  -521,  -521,  -521,   269,   355,  -521,
     289,   270,  -521,   276,  -521,   477,    61,   355,   646,   646,
     478,   479,   646,   646,   482,   491,   646,   493,   646,   646,
    2080,   646,   646,   494,   -78,   497,   646,  2667,   646,   646,
    2667,   194,  2667,  2667,    61,    75,   501,  2667,  2819,   308,
    -521,   309,  -521,  -521,  -521,   311,  -521,   314,  -521,  -521,
    -521,    15,  2593,  -521,   326,  -521,  -521,  -521,  -521,   326,
    -102,  -521,  -521,   -37,  -521,   332,   -66,   320,   329,  -521,
    -521,  1130,    72,   327,  -521,   646,   266,  2080,  -521,  -521,
    -521,   333,   353,  -521,   328,   534,  -521,   -30,   177,   -21,
     335,  -521,  -521,   336,   341,  -521,  -521,  -521,  -521,  -521,
    -521,  -521,  -521,  -521,   339,  -521,   646,   646,   646,   646,
     646,   646,   575,  2328,  -143,  -521,  2328,   342,   344,  -521,
    -123,   346,   348,   349,   351,   352,   354,   357,  1334,   358,
    2593,   159,   359,  -118,  -521,  2328,   362,   363,   364,   367,
     365,  -114,  2001,   368,  -521,  -521,  -521,  -521,  -521,   370,
     378,   379,   380,   374,  -521,   381,   382,   383,  -521,  2819,
     543,  -521,  -521,  -521,   162,    15,   -23,  -521,  1027,  -521,
     375,  2593,   387,  1410,   389,   474,  1233,    15,  -521,  2593,
    -521,  -521,  -521,  -521,   594,  -521,  2242,   390,   414,  -521,
    -521,  -521,   355,   646,  -521,    18,  -521,  2593,  -521,   397,
    -521,   391,  -521,   401,  -521,  -521,  -521,  2593,    12,    12,
      12,    12,    12,    12,  2111,   338,   646,   646,   607,   646,
     646,   646,   646,   646,   646,   646,   646,   646,   646,   646,
     646,   646,   646,   646,   646,   646,   608,   646,   646,  -521,
    -521,  -521,   604,  -521,  -521,  -521,  -521,  -521,  -521,  -521,
    -521,  -521,  -521,   159,  -521,  1775,  -521,   159,  -521,  -521,
    -521,   -93,  -521,   646,  -521,  -521,  -521,  -521,   646,  -521,
    -521,  -521,  -521,  -521,  -521,  -521,  -521,   610,  -521,  -521,
    -521,  -521,   405,  -521,  -521,   435,  -521,  -521,  -521,  -521,
     162,   169,  -521,  -521,  2593,   413,  -521,  -521,  -521,    15,
    -521,  -521,  -521,  -521,  2006,  -521,  -521,  -521,  -521,   159,
     419,   355,  -521,  -521,   338,  -521,  -521,  1903,  -521,   338,
    -521,   420,   -58,   204,   204,  -521,   718,   718,   305,   305,
    2198,  2347,  2307,   103,   506,  2354,   305,   305,   115,   115,
      12,    12,    12,  -521,  2270,  -521,  -521,  -521,   340,  -521,
     421,   159,   423,  -521,  2080,  -521,  -521,   425,  -521,    15,
     909,   162,  -521,  -521,  1336,  -521,  -521,  -521,   444,  -521,
    -115,  -521,   431,  -521,   429,   498,  -521,   430,   159,   434,
    -521,   646,  2080,  -521,   646,  -521,  -521,   340,  -521,  -521,
    -521,   437,  -521,  -521,  -521,  -521,    15,   646,  -521,   159,
    -521,  -521,  -521,  -521,   340,  -521,  -521,  -521,    12,   438,
    2328,  -521,  -521,  -521,  -521,  -521,   -13,  -521,  -521,   646,
     475,  -521,  -521,   476,   -52,   -52,  -521,  -521,   454,  -521,
    -521
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -521,  -521,   360,  -521,   -42,  -521,  -304,  -291,     0,  -521,
    -521,  -521,  -521,  -521,   227,  -521,  -521,  -521,    10,  -472,
    -521,  -521,  -266,  -218,  -191,    -2,  -521,  -521,  -275,   369,
     -65,  -521,  -521,  -521,  -521,   216,    13,   377,   143,  -242,
    -521,  -228,  -264,  -521,  -521,  -521,  -521,   -18,  -177,  -521,
     237,  -521,    -3,   -67,  -521,   110,   116,     5,  -521,    11,
      17,  -521,  -521,   624,  -521,  -521,  -521,  -521,  -521,   -33,
    -521,    19,    16,  -521,  -521,    20,  -521,  -521,  -298,  -462,
     -49,    32,    30,  -235,  -521,  -521,  -521,  -495,  -521,  -520,
    -521,  -448,  -521,  -521,  -521,    22,  -521,   456,  -521,   392,
       1,   -31,  -521,     7,  -521
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -260
static const yytype_int16 yytable[] =
{
      50,   219,    41,    73,   247,   206,   246,    55,   381,    76,
     333,   334,    48,    57,   389,    51,   312,   217,    65,    58,
     423,    64,    67,   418,   567,   679,   436,   376,   478,  -259,
     376,   338,    97,    99,   440,    12,   263,   388,   680,   498,
     395,   253,   430,   610,    25,   382,   395,   402,   385,   628,
     387,   220,   608,   392,  -259,   215,   174,   221,   399,   502,
     178,   298,   261,   214,   523,   607,   499,   659,   523,   613,
     351,   443,    79,   352,   325,   238,    25,   239,  -259,   634,
     -43,   413,   414,   299,   640,   264,   503,   192,    10,     3,
      85,   524,   660,   376,   446,   530,    87,   441,   235,   235,
     235,   236,   237,  -259,   235,   637,   255,   336,    91,    92,
     336,   240,   337,    16,   635,   614,    10,   476,   477,   478,
     479,   480,   481,   482,   468,   469,   470,   471,   472,   473,
     474,   478,   426,    93,   546,   431,    90,    40,    21,   628,
     663,    94,   651,   241,   541,   336,   560,   647,    95,   432,
     642,    40,   247,   100,   246,   686,   457,   431,   431,    77,
     646,    78,   238,   649,   239,   238,    40,   239,   204,   425,
     669,   459,   463,    40,   664,    80,   456,    81,   247,   247,
     246,   246,    40,    29,    82,   460,    83,   207,   -38,   544,
     666,   344,   222,   681,   327,    34,   223,   242,   240,   671,
     354,   240,   471,    50,    50,   231,    73,    73,    97,    99,
     226,   224,    76,    76,   496,   497,   677,   257,    51,    51,
     478,    88,   228,    89,   243,   566,    96,   568,    83,   225,
     241,   391,   227,   241,   583,   584,   230,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   624,   604,   400,   578,    98,   403,
      83,   410,   411,   424,   244,   247,   417,   246,   625,   355,
     605,   233,   356,   357,   358,   359,   360,   361,   390,   258,
     245,   395,   260,   235,   242,   339,   -40,   242,   391,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   627,  -259,
     617,   -39,  -259,   615,   -41,   496,   497,   493,   494,   495,
     440,   243,   262,   256,   243,   622,   -42,   496,   497,   476,
     477,   478,   314,   475,    83,   315,   259,   316,   653,   439,
     265,   438,    73,   266,   267,   390,   362,   440,    76,   268,
     317,   513,   318,   238,    51,   239,   319,   461,    83,   440,
     320,   514,    83,   328,   244,   329,   578,   247,   238,   246,
     239,   578,   336,   269,   643,   673,   440,   515,   270,   271,
     245,   404,   405,   406,   407,   408,  -252,   240,  -252,   240,
      40,   272,   550,   363,    10,   344,   655,   273,   274,   -44,
     219,   275,   276,   674,   491,   492,   493,   494,   495,   668,
     277,   278,   670,   279,   280,   281,   496,   497,   569,   241,
     579,   241,   321,   282,   364,   376,   -45,   578,   574,   283,
     284,   285,   286,   287,     8,   288,    50,   365,    41,    73,
     289,   554,   551,    55,   439,    76,   438,    73,    48,    57,
     220,    51,   547,    76,    65,    58,   221,    64,    67,    51,
     611,   683,   214,   366,   290,   291,   367,   368,   444,   292,
     293,   370,   371,   242,   570,   242,   391,    19,   294,   295,
     445,   296,   297,   345,   372,   -46,   330,   335,   340,   346,
      22,    23,    24,   247,   348,   246,   350,   378,   379,    26,
     243,   383,   243,   431,   431,   491,   492,   493,   494,   495,
     384,   620,   386,   396,   633,   219,   398,   496,   497,   579,
     416,   419,   638,   390,   579,   391,   429,   420,   421,   422,
     476,   477,   478,   479,   480,   481,   482,   434,   391,    31,
     576,  -259,   514,    33,   435,   452,   442,   240,   453,   451,
     454,   336,    10,   336,   464,   465,   577,   467,   515,   528,
     466,   500,   542,   501,   247,   504,   246,   505,   506,   549,
     507,   508,   390,   509,    20,   391,   510,   512,   522,   241,
     579,   525,   526,   527,   529,   390,   537,   532,   355,   533,
       5,   356,   357,   358,   359,   360,   361,   534,   535,   536,
     538,   539,   540,   391,   552,   557,   564,   355,   572,   563,
     356,   357,   358,   359,   360,   361,   571,     6,   573,     7,
     585,   603,   390,   606,   619,     8,   618,   621,    50,    10,
     623,    73,   439,   242,   438,    73,   631,    76,   657,   641,
     648,    76,   650,    51,   652,    13,   661,    51,   662,   665,
     390,   208,    15,   667,    16,   362,   672,   678,    17,   355,
     243,    18,   356,   357,   358,   359,   360,   361,    19,   684,
     685,   690,   558,   412,   362,   401,   616,   689,   565,    21,
     556,    22,    23,    24,   216,   322,   397,     0,     0,     0,
      26,   675,     0,     0,   428,     0,     0,     0,     0,     0,
     576,     0,   363,   488,   489,   490,   491,   492,   493,   494,
     495,   336,     0,     0,     0,     0,   577,     0,   496,   497,
       0,   363,     0,     0,    29,     0,   362,     0,     0,    30,
      31,    32,     0,   364,    33,     0,    34,     0,     0,     0,
     211,     0,   476,   477,   478,     0,   365,   481,   482,   212,
       0,    37,   364,     0,     0,     0,     0,     0,     0,    38,
      39,     0,     0,     0,     0,   365,     0,     0,     0,     0,
       0,     0,   366,   363,     0,   367,   368,   369,     0,     0,
     370,   371,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   366,     0,   372,   367,   368,   369,     0,     0,   370,
     371,     0,     0,     0,   364,     4,     5,     0,   561,     0,
       0,     0,   372,     0,     0,     0,     0,   365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     0,     7,     0,     0,     0,     0,
       0,     8,     9,   366,     0,    10,   367,   368,   369,     0,
      11,   370,   371,     0,     0,     0,     0,     0,     0,    12,
       0,    13,     0,     0,   372,     0,     0,    14,    15,     0,
      16,     0,     0,     0,    17,     0,     0,    18,     0,     0,
       0,     0,     0,     0,    19,     0,     0,     0,     0,     0,
       0,    20,   301,     0,     0,    21,     0,    22,    23,    24,
      25,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,    27,     0,     0,     0,     0,   489,   490,   491,   492,
     493,   494,   495,     4,     5,     0,     0,     0,    28,     0,
     496,   497,     0,     0,     0,     0,     0,     0,     0,     0,
      29,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     6,    34,     7,     0,     0,    35,     0,     0,     8,
       9,     0,     0,    10,     0,    36,     0,    37,    11,     0,
       0,     0,     0,     0,     0,    38,    39,    12,     0,    13,
       0,     0,     0,     0,     0,    14,    15,     0,    16,     0,
       0,     0,    17,     0,     0,    18,     0,     0,     0,     0,
       0,     0,    19,     0,    40,     0,     0,   311,     0,    20,
     301,     0,     0,    21,     0,    22,    23,    24,    25,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     5,     0,     0,     0,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,    30,    31,    32,     0,     0,    33,     6,
      34,     7,     0,     0,    35,     0,     0,     8,     9,     0,
       0,    10,     0,    36,     0,    37,    11,     0,     0,     0,
       0,     0,     0,    38,    39,    12,     0,    13,     0,     0,
       0,     0,     0,    14,    15,     0,    16,     0,     0,     0,
      17,     0,     0,    18,     0,     0,     0,     0,     0,     0,
      19,     0,    40,     0,     0,   654,     0,    20,     0,     0,
       0,    21,     0,    22,    23,    24,    25,     0,     0,     0,
       0,     0,    26,     0,     4,     5,     0,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,     0,
       0,     0,     6,     0,     7,     0,    29,     0,     0,     0,
       8,    30,    31,    32,    10,     0,    33,     0,    34,    11,
       0,     0,    35,     0,     0,     0,     0,     0,     0,     0,
      13,    36,     0,    37,     0,     0,    14,    15,     0,    16,
       0,    38,    39,    17,     0,     0,    18,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,    21,     0,    22,    23,    24,     0,
      40,     0,     0,   548,     0,    26,     0,     4,     5,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     6,     0,     7,     0,    29,
       0,     0,     0,     8,    30,    31,    32,    10,     0,    33,
       0,    34,    11,     0,     0,    35,     0,     0,     0,     0,
       0,     0,     0,    13,    36,     0,    37,     0,     0,    14,
      15,     0,    16,     0,    38,    39,    17,     0,     0,    18,
       0,     0,     0,     0,     0,     0,    19,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,    21,     0,    22,
      23,    24,     0,    40,     0,     0,   437,     0,    26,     0,
       4,     5,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     6,     0,
       7,     0,    29,     0,     0,     0,     8,    30,    31,    32,
      10,     0,    33,     0,    34,    11,     0,     0,    35,     0,
       0,     0,     0,     0,     0,     0,    13,    36,     0,    37,
       0,     0,    14,    15,     0,    16,     0,    38,    39,    17,
       0,     0,    18,     0,     0,     5,     0,     0,     0,    19,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
      21,     0,    22,    23,    24,     0,    40,     0,     0,   559,
       0,    26,     6,     0,     7,     0,     0,     0,     0,     0,
       8,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,    29,   208,    15,     0,    16,
      30,    31,    32,    17,     0,    33,    18,    34,     0,     0,
       0,    35,     0,    19,     0,     0,     0,     0,     0,     0,
      36,     0,    37,     0,    21,     0,    22,    23,    24,     0,
      38,    39,     0,     0,     0,    26,     0,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
       0,     0,     4,     5,     0,     0,   496,   497,     0,    40,
       0,   300,   656,   511,     0,     0,     0,     0,     0,    29,
       0,     0,     0,     0,    30,    31,    32,     0,     0,    33,
       6,    34,     7,     0,     0,   211,     0,     0,     8,     9,
       0,     0,    10,     0,   212,     0,    37,    11,     0,     0,
       0,     0,     0,     0,    38,    39,    12,     0,    13,     0,
       0,     0,     0,     0,    14,    15,     0,    16,     0,     0,
       0,    17,     0,     0,    18,     0,     0,     0,     0,     0,
       0,    19,     0,    40,     0,     0,   553,     0,    20,   301,
       0,     0,    21,     0,    22,    23,    24,    25,     0,     0,
       0,     0,     0,    26,     0,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       4,     5,     0,     0,     0,    28,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    29,     0,     0,
       0,     0,    30,    31,    32,     0,     0,    33,     6,    34,
       7,     0,     0,    35,     0,     0,     8,     9,     0,     0,
      10,     0,    36,     0,    37,    11,     0,     0,     0,     0,
       0,     0,    38,    39,    12,     0,    13,     0,     0,     0,
       0,     0,    14,    15,     0,    16,     0,     0,     0,    17,
       0,     0,    18,     0,     0,     0,     0,     0,     0,    19,
       0,    40,     0,     0,     0,     0,    20,     0,     0,     0,
      21,     0,    22,    23,    24,    25,     0,     0,     0,     0,
       0,    26,     0,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
       5,     0,     0,     0,     0,    29,     0,     0,     0,     0,
      30,    31,    32,     0,     0,    33,     0,    34,     0,     0,
       0,    35,     0,     0,     0,     0,     0,     6,   -66,     7,
      36,     0,    37,     0,   240,     8,     0,     0,     0,    10,
      38,    39,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
       0,   208,    15,     0,    16,     0,   241,     0,    17,    40,
       0,    18,     0,     0,     0,     0,     0,     0,    19,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    21,
       0,    22,    23,    24,     0,     0,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     242,     0,     0,     0,     0,     0,     0,     0,     5,     0,
       0,     0,     0,     0,    29,     0,     0,     0,     0,    30,
      31,    32,     0,     0,    33,     0,    34,   243,     0,     0,
     211,     0,     0,     0,     0,     6,     0,     7,     0,   212,
       0,    37,   240,     8,     0,     0,     0,    10,     0,    38,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    13,     0,     0,     0,   609,     0,   208,
      15,     0,    16,     0,   241,     0,    17,     0,    40,    18,
       0,     0,     0,     0,     0,     0,    19,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,    22,
      23,    24,     0,     0,     0,     0,     0,     0,    26,     0,
       0,     5,     0,     0,     0,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,     0,     0,   242,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     0,
       7,     0,    29,     0,     0,     0,     8,    30,    31,    32,
      10,     0,    33,     0,    34,   243,     0,     0,   211,     0,
       0,     0,     0,     0,     0,     0,    13,   212,     0,    37,
       0,     0,   208,    15,     0,    16,     0,    38,    39,    17,
       0,     0,    18,     0,     0,     5,     0,     0,     0,    19,
       0,     0,     0,     0,     0,   636,     0,     0,     0,     0,
      21,     0,    22,    23,    24,     0,    40,     0,     0,     0,
       0,    26,     6,     0,     7,     0,     0,     0,     0,     0,
       8,     0,     0,     0,    10,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,    29,   208,    15,     0,    16,
      30,    31,    32,    17,     0,    33,    18,    34,     0,     0,
       0,   211,     0,    19,     0,     0,     0,     0,     0,     0,
     212,     0,    37,     0,    21,     0,    22,    23,    24,     0,
      38,    39,     0,     0,   485,    26,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,     0,     0,     0,
       0,     0,     0,   496,   497,     0,     0,     0,     0,    40,
     531,     0,   476,   477,   478,   479,   480,   481,   482,    29,
     484,     0,     0,     0,    30,    31,    32,     0,     0,    33,
       0,    34,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,     0,     0,   212,     0,    37,     0,     0,     0,
       0,     0,     0,     0,    38,    39,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    40,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,     0,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,     0,     0,     0,
       0,     0,     0,   496,   497,     0,     0,     0,     0,     0,
     575,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   476,   477,
     478,   479,   480,   481,   482,     0,     0,     0,     0,     0,
       0,     0,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,     0,     0,     0,     0,     0,     0,
     496,   497,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,     0,     0,
       0,     0,     0,     0,   496,   497,   562,     0,     0,     0,
       0,     0,     0,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,     0,     0,     0,     0,
       0,     0,   496,   497,   645,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     485,   644,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,     0,     0,     0,     0,     0,     0,   496,
     497,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,     5,     0,     0,     0,     0,     0,
     496,   497,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     6,     0,     7,     0,     0,   496,   497,     0,     8,
       9,     0,     0,    10,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,     0,    13,
       0,     0,     0,     0,     0,   208,    15,     0,    16,     0,
       0,     0,    17,     0,     0,    18,     0,     0,     5,     0,
       0,     0,    19,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,    22,    23,    24,    25,     0,
       0,   209,     0,     0,    26,     6,     0,     7,   210,     0,
       0,     0,     0,     8,     0,     0,     0,    10,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,    29,   208,
      15,     0,    16,    30,    31,    32,    17,     0,    33,    18,
      34,     0,     5,     0,   211,     0,    19,     0,     0,     0,
       0,     0,     0,   212,     0,    37,     0,    21,     0,    22,
      23,    24,     0,    38,    39,     0,     0,     0,    26,     6,
       0,     7,     0,     0,     0,     0,     0,     8,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,    29,   208,    15,     0,     0,    30,    31,    32,
      17,     0,    33,    18,    34,     0,     0,     0,   211,     0,
      19,     0,     0,     0,     0,     0,     0,   212,     0,    37,
       0,     0,     0,    22,    23,    24,     0,    38,    39,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,    31,    32,     0,     0,    33,     0,     0,     0,
       0,     0,   211,     0,     0,     0,     0,     0,     0,     0,
       0,   212,     0,    37,     0,     0,     0,     0,     0,     0,
       0,    38,    39,   101,     0,   102,   103,   104,   105,   106,
     107,     0,   108,     0,     0,   109,     0,   110,     0,     0,
       0,   111,   112,     0,   113,   114,   115,   116,     0,   117,
     118,   119,   120,   121,   122,   123,   124,     0,   125,     0,
     126,   127,   128,   129,   130,     0,     0,   131,     0,     0,
       0,   132,     0,   133,   134,     0,   135,   136,   137,   138,
     139,   140,     0,   141,   142,   143,   144,   145,   146,     0,
       0,   147,     0,     0,   148,     0,     0,     0,     0,   149,
     150,     0,   151,   152,     0,   153,   154,     0,     0,     0,
     155,   156,   157,   158,   159,   160,     0,   161,   162,   163,
     164,   165,   166,   167,     0,   168,     0,   169,     0,   170,
     171,   172,   173,   174,   175,   176,   177,   178,     0,   179,
     180,   181,   182,     0,     0,     0,   183,     0,     0,   184,
       0,     0,   185,   186,     0,     0,   187,   188,   189,   190,
       0,     0,   191,     0,   192,     0,   193,   194,   195,   196,
     197,   198,   199,     0,     0,   200
};

static const yytype_int16 yycheck[] =
{
       2,    50,     2,     2,    71,    47,    71,     2,   272,     2,
     245,   246,     2,     2,   280,     2,   207,    50,     2,     2,
     311,     2,     2,   298,     6,    38,   330,   269,    16,   156,
     272,   249,    35,    36,   332,    58,   156,   279,    51,   182,
     282,    72,   108,   515,    99,   273,   288,   289,   276,   569,
     278,    50,   514,   281,   156,    50,   134,    50,   286,   182,
     138,   182,    93,    50,   182,   513,   209,   182,   182,   517,
       9,   335,   208,    12,   129,     3,    99,     5,   205,   574,
     207,     6,     7,   204,   579,   205,   209,   165,    44,     0,
      96,   209,   207,   335,   336,   209,     9,   332,    68,    69,
      70,    69,    70,   205,    74,   577,    74,   203,     3,   208,
     203,    39,   208,    69,   576,   208,    44,    14,    15,    16,
      17,    18,    19,    20,   366,   367,   368,   369,   370,   371,
     372,    16,   323,   208,   425,   326,    26,   203,    94,   659,
     635,    31,   614,    71,   419,   203,   437,   609,    32,   326,
     208,   203,   219,    37,   219,   207,   347,   348,   349,     3,
     608,     5,     3,   611,     5,     3,   203,     5,   207,   206,
     642,   348,   349,   203,   636,     3,   206,     5,   245,   246,
     245,   246,   203,   139,     3,   206,     5,   162,   207,   424,
     638,   258,   207,   206,   227,   151,   207,   125,    39,   647,
     267,    39,   444,   205,   206,   184,   205,   206,   211,   212,
     207,   205,   205,   206,   202,   203,   664,     9,   205,   206,
      16,     3,   207,     5,   152,   453,     3,   209,     5,   205,
      71,   280,   205,    71,   476,   477,   207,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   558,   497,   287,   475,     3,   290,
       5,   292,   293,   312,   192,   332,   297,   332,   559,     3,
     498,   205,     6,     7,     8,     9,    10,    11,   280,   205,
     208,   523,     3,   253,   125,   253,   207,   125,   337,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   564,   205,
     528,   207,   205,   521,   207,   202,   203,   192,   193,   194,
     608,   152,   205,   207,   152,   550,   207,   202,   203,    14,
      15,    16,     3,   372,     5,     3,   207,     5,   619,   331,
     208,   331,   331,   208,   208,   337,    70,   635,   331,   208,
       3,   390,     5,     3,   331,     5,     3,   349,     5,   647,
       3,   192,     5,     3,   192,     5,   574,   424,     3,   424,
       5,   579,   203,   208,   582,   656,   664,   208,   208,   208,
     208,   177,   178,   179,   180,   181,   207,    39,   209,    39,
     203,   208,   431,   117,    44,   452,   621,   208,   208,   207,
     439,   208,   208,   657,   190,   191,   192,   193,   194,   641,
     208,   208,   644,   208,   208,   208,   202,   203,   457,    71,
     475,    71,   205,   208,   148,   657,   207,   635,   467,   208,
     208,   208,   208,   208,    40,   208,   428,   161,   428,   428,
     208,   433,   431,   428,   436,   428,   436,   436,   428,   428,
     439,   428,   426,   436,   428,   428,   439,   428,   428,   436,
     515,   679,   439,   187,   208,   208,   190,   191,   192,   208,
     208,   195,   196,   125,   457,   125,   515,    83,   208,   208,
     204,   208,   208,   184,   208,   207,   205,   210,   209,   209,
      96,    97,    98,   550,   208,   550,     9,     9,     9,   105,
     152,     9,   152,   684,   685,   190,   191,   192,   193,   194,
       9,   543,     9,     9,   571,   554,     9,   202,   203,   574,
       9,   203,   577,   515,   579,   564,   184,   208,   207,   205,
      14,    15,    16,    17,    18,    19,    20,   207,   577,   145,
     192,   205,   192,   149,   205,   182,   209,    39,   210,   206,
       6,   203,    44,   203,   209,   209,   208,   208,   208,   182,
     209,   209,     9,   209,   621,   209,   621,   209,   209,   184,
     209,   209,   564,   209,    90,   614,   209,   209,   209,    71,
     635,   209,   209,   209,   209,   577,   202,   209,     3,   209,
       5,     6,     7,     8,     9,    10,    11,   209,   209,   209,
     209,   209,   209,   642,   207,   206,   182,     3,   207,   209,
       6,     7,     8,     9,    10,    11,   209,    32,   207,    34,
       3,     3,   614,     9,   209,    40,     6,   182,   620,    44,
     207,   620,   624,   125,   624,   624,   207,   620,   184,   209,
     209,   624,   209,   620,   209,    60,   205,   624,   209,   209,
     642,    66,    67,   209,    69,    70,   209,   209,    73,     3,
     152,    76,     6,     7,     8,     9,    10,    11,    83,   184,
     184,   207,   435,   294,    70,   288,   523,   685,   452,    94,
     433,    96,    97,    98,    50,   219,   284,    -1,    -1,    -1,
     105,   659,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,
     192,    -1,   117,   187,   188,   189,   190,   191,   192,   193,
     194,   203,    -1,    -1,    -1,    -1,   208,    -1,   202,   203,
      -1,   117,    -1,    -1,   139,    -1,    70,    -1,    -1,   144,
     145,   146,    -1,   148,   149,    -1,   151,    -1,    -1,    -1,
     155,    -1,    14,    15,    16,    -1,   161,    19,    20,   164,
      -1,   166,   148,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,    -1,    -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,
      -1,    -1,   187,   117,    -1,   190,   191,   192,    -1,    -1,
     195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   187,    -1,   208,   190,   191,   192,    -1,    -1,   195,
     196,    -1,    -1,    -1,   148,     4,     5,    -1,   204,    -1,
      -1,    -1,   208,    -1,    -1,    -1,    -1,   161,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    40,    41,   187,    -1,    44,   190,   191,   192,    -1,
      49,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    60,    -1,    -1,   208,    -1,    -1,    66,    67,    -1,
      69,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    -1,    -1,    94,    -1,    96,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,    -1,    -1,   188,   189,   190,   191,
     192,   193,   194,     4,     5,    -1,    -1,    -1,   127,    -1,
     202,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,   144,   145,   146,    -1,    -1,
     149,    32,   151,    34,    -1,    -1,   155,    -1,    -1,    40,
      41,    -1,    -1,    44,    -1,   164,    -1,   166,    49,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,    58,    -1,    60,
      -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    69,    -1,
      -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    83,    -1,   203,    -1,    -1,   206,    -1,    90,
      91,    -1,    -1,    94,    -1,    96,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     4,     5,    -1,    -1,    -1,   127,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,   144,   145,   146,    -1,    -1,   149,    32,
     151,    34,    -1,    -1,   155,    -1,    -1,    40,    41,    -1,
      -1,    44,    -1,   164,    -1,   166,    49,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,    58,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    66,    67,    -1,    69,    -1,    -1,    -1,
      73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    -1,   203,    -1,    -1,   206,    -1,    90,    -1,    -1,
      -1,    94,    -1,    96,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,   105,    -1,     4,     5,    -1,   110,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    -1,    34,    -1,   139,    -1,    -1,    -1,
      40,   144,   145,   146,    44,    -1,   149,    -1,   151,    49,
      -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,   164,    -1,   166,    -1,    -1,    66,    67,    -1,    69,
      -1,   174,   175,    73,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    -1,    96,    97,    98,    -1,
     203,    -1,    -1,   206,    -1,   105,    -1,     4,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    34,    -1,   139,
      -1,    -1,    -1,    40,   144,   145,   146,    44,    -1,   149,
      -1,   151,    49,    -1,    -1,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,   164,    -1,   166,    -1,    -1,    66,
      67,    -1,    69,    -1,   174,   175,    73,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    -1,    96,
      97,    98,    -1,   203,    -1,    -1,   206,    -1,   105,    -1,
       4,     5,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
     127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      34,    -1,   139,    -1,    -1,    -1,    40,   144,   145,   146,
      44,    -1,   149,    -1,   151,    49,    -1,    -1,   155,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,   164,    -1,   166,
      -1,    -1,    66,    67,    -1,    69,    -1,   174,   175,    73,
      -1,    -1,    76,    -1,    -1,     5,    -1,    -1,    -1,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    -1,    96,    97,    98,    -1,   203,    -1,    -1,   206,
      -1,   105,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    -1,    -1,    -1,    -1,   139,    66,    67,    -1,    69,
     144,   145,   146,    73,    -1,   149,    76,   151,    -1,    -1,
      -1,   155,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,
     164,    -1,   166,    -1,    94,    -1,    96,    97,    98,    -1,
     174,   175,    -1,    -1,    -1,   105,    -1,   183,    -1,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,    -1,
      -1,    -1,     4,     5,    -1,    -1,   202,   203,    -1,   203,
      -1,    13,   206,   209,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,   144,   145,   146,    -1,    -1,   149,
      32,   151,    34,    -1,    -1,   155,    -1,    -1,    40,    41,
      -1,    -1,    44,    -1,   164,    -1,   166,    49,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   175,    58,    -1,    60,    -1,
      -1,    -1,    -1,    -1,    66,    67,    -1,    69,    -1,    -1,
      -1,    73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    -1,   203,    -1,    -1,   206,    -1,    90,    91,
      -1,    -1,    94,    -1,    96,    97,    98,    99,    -1,    -1,
      -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,   110,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       4,     5,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,   144,   145,   146,    -1,    -1,   149,    32,   151,
      34,    -1,    -1,   155,    -1,    -1,    40,    41,    -1,    -1,
      44,    -1,   164,    -1,   166,    49,    -1,    -1,    -1,    -1,
      -1,    -1,   174,   175,    58,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    66,    67,    -1,    69,    -1,    -1,    -1,    73,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      -1,   203,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    -1,    96,    97,    98,    99,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
       5,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    -1,    -1,    32,   162,    34,
     164,    -1,   166,    -1,    39,    40,    -1,    -1,    -1,    44,
     174,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    66,    67,    -1,    69,    -1,    71,    -1,    73,   203,
      -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    96,    97,    98,    -1,    -1,    -1,    -1,    -1,    -1,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,   144,
     145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    32,    -1,    34,    -1,   164,
      -1,   166,    39,    40,    -1,    -1,    -1,    44,    -1,   174,
     175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    -1,    -1,    -1,   192,    -1,    66,
      67,    -1,    69,    -1,    71,    -1,    73,    -1,   203,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,     5,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    -1,    -1,    -1,    -1,   125,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      34,    -1,   139,    -1,    -1,    -1,    40,   144,   145,   146,
      44,    -1,   149,    -1,   151,   152,    -1,    -1,   155,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,   164,    -1,   166,
      -1,    -1,    66,    67,    -1,    69,    -1,   174,   175,    73,
      -1,    -1,    76,    -1,    -1,     5,    -1,    -1,    -1,    83,
      -1,    -1,    -1,    -1,    -1,   192,    -1,    -1,    -1,    -1,
      94,    -1,    96,    97,    98,    -1,   203,    -1,    -1,    -1,
      -1,   105,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    44,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    -1,    -1,    -1,    -1,   139,    66,    67,    -1,    69,
     144,   145,   146,    73,    -1,   149,    76,   151,    -1,    -1,
      -1,   155,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,
     164,    -1,   166,    -1,    94,    -1,    96,    97,    98,    -1,
     174,   175,    -1,    -1,   183,   105,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   202,   203,    -1,    -1,    -1,    -1,   203,
     209,    -1,    14,    15,    16,    17,    18,    19,    20,   139,
      22,    -1,    -1,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   164,    -1,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   175,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    -1,   183,    -1,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     202,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   183,    -1,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   202,   203,   204,    -1,    -1,    -1,
      -1,    -1,    -1,   183,    -1,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   202,   203,   204,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,   183,    -1,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,    -1,     5,    -1,    -1,    -1,    -1,    -1,
     202,   203,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   188,   189,   190,   191,   192,   193,   194,   202,
     203,    32,    -1,    34,    -1,    -1,   202,   203,    -1,    40,
      41,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,
      -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    69,    -1,
      -1,    -1,    73,    -1,    -1,    76,    -1,    -1,     5,    -1,
      -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    -1,    96,    97,    98,    99,    -1,
      -1,   102,    -1,    -1,   105,    32,    -1,    34,   109,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,   139,    66,
      67,    -1,    69,   144,   145,   146,    73,    -1,   149,    76,
     151,    -1,     5,    -1,   155,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,   164,    -1,   166,    -1,    94,    -1,    96,
      97,    98,    -1,   174,   175,    -1,    -1,    -1,   105,    32,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,
      -1,    -1,   139,    66,    67,    -1,    -1,   144,   145,   146,
      73,    -1,   149,    76,   151,    -1,    -1,    -1,   155,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,   166,
      -1,    -1,    -1,    96,    97,    98,    -1,   174,   175,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   144,   145,   146,    -1,    -1,   149,    -1,    -1,    -1,
      -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   164,    -1,   166,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,    24,    -1,    26,    27,    28,    29,    30,
      31,    -1,    33,    -1,    -1,    36,    -1,    38,    -1,    -1,
      -1,    42,    43,    -1,    45,    46,    47,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    68,    -1,    -1,
      -1,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    -1,    -1,    95,    -1,    -1,    -1,    -1,   100,
     101,    -1,   103,   104,    -1,   106,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
     121,   122,   123,   124,    -1,   126,    -1,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
     141,   142,   143,    -1,    -1,    -1,   147,    -1,    -1,   150,
      -1,    -1,   153,   154,    -1,    -1,   157,   158,   159,   160,
      -1,    -1,   163,    -1,   165,    -1,   167,   168,   169,   170,
     171,   172,   173,    -1,    -1,   176
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   212,   213,     0,     4,     5,    32,    34,    40,    41,
      44,    49,    58,    60,    66,    67,    69,    73,    76,    83,
      90,    94,    96,    97,    98,    99,   105,   110,   127,   139,
     144,   145,   146,   149,   151,   155,   164,   166,   174,   175,
     203,   219,   220,   222,   223,   224,   225,   228,   229,   235,
     236,   247,   261,   265,   267,   268,   269,   270,   271,   274,
     275,   278,   280,   281,   282,   283,   285,   286,   287,   288,
     289,   291,   293,   311,   312,   313,   314,     3,     5,   208,
       3,     5,     3,     5,   263,    96,   266,     9,     3,     5,
     266,     3,   208,   208,   266,   267,     3,   263,     3,   263,
     267,    24,    26,    27,    28,    29,    30,    31,    33,    36,
      38,    42,    43,    45,    46,    47,    48,    50,    51,    52,
      53,    54,    55,    56,    57,    59,    61,    62,    63,    64,
      65,    68,    72,    74,    75,    77,    78,    79,    80,    81,
      82,    84,    85,    86,    87,    88,    89,    92,    95,   100,
     101,   103,   104,   106,   107,   111,   112,   113,   114,   115,
     116,   118,   119,   120,   121,   122,   123,   124,   126,   128,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   140,
     141,   142,   143,   147,   150,   153,   154,   157,   158,   159,
     160,   163,   165,   167,   168,   169,   170,   171,   172,   173,
     176,   237,   239,   310,   207,   215,   215,   162,    66,   102,
     109,   155,   164,   227,   247,   268,   274,   280,   284,   291,
     311,   314,   207,   207,   205,   205,   207,   205,   207,   218,
     207,   184,   279,   205,   292,   293,   292,   292,     3,     5,
      39,    71,   125,   152,   192,   208,   241,   264,   294,   295,
     308,   247,   311,   312,   314,   292,   207,     9,   205,   207,
       3,   312,   205,   156,   205,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   208,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   208,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   208,   208,   208,   208,   182,   204,
      13,    91,   219,   226,   229,   268,   270,   271,   282,   283,
     286,   206,   235,   236,     3,     3,     5,     3,     5,     3,
       3,   205,   308,   272,   214,   129,   276,   280,     3,     5,
     205,   217,   290,   294,   294,   210,   203,   208,   234,   292,
     209,   244,   245,   246,   264,   184,   209,   254,   208,   257,
       9,     9,    12,   240,   264,     3,     6,     7,     8,     9,
      10,    11,    70,   117,   148,   161,   187,   190,   191,   192,
     195,   196,   208,   250,   251,   252,   250,   253,     9,     9,
     238,   253,   252,     9,     9,   252,     9,   252,   250,   233,
     236,   291,   252,   248,   249,   250,     9,   310,     9,   252,
     312,   248,   250,   312,   177,   178,   179,   180,   181,   309,
     312,   312,   240,     6,     7,   315,     9,   312,   239,   203,
     208,   207,   205,   218,   291,   206,   235,   273,   213,   184,
     108,   235,   259,   277,   207,   205,   217,   206,   219,   236,
     289,   294,   209,   253,   192,   204,   250,   230,   231,   232,
     233,   206,   182,   210,     6,   221,   206,   235,   255,   259,
     206,   236,   256,   259,   209,   209,   209,   208,   250,   250,
     250,   250,   250,   250,   250,   291,    14,    15,    16,    17,
      18,    19,    20,    21,    22,   183,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   202,   203,   182,   209,
     209,   209,   182,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   291,   192,   208,   234,   241,   264,   300,
     302,   303,   209,   182,   209,   209,   209,   209,   182,   209,
     209,   209,   209,   209,   209,   209,   209,   202,   209,   209,
     209,   239,     9,   216,   294,   304,   218,   283,   206,   184,
     291,   311,   207,   206,   236,   260,   261,   206,   225,   206,
     218,   204,   204,   209,   182,   246,   252,     6,   209,   291,
     314,   209,   207,   207,   291,   209,   192,   208,   234,   241,
     296,   298,   299,   250,   250,     3,   250,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   250,
     250,   250,   250,     3,   250,   252,     9,   302,   290,   192,
     230,   241,   301,   302,   208,   234,   249,   252,     6,   209,
     215,   182,   294,   207,   217,   218,    23,   233,   300,   306,
     307,   207,   262,   264,   298,   290,   192,   230,   241,   297,
     298,   209,   208,   234,   184,   204,   302,   290,   209,   302,
     209,   230,   209,   218,   206,   294,   206,   184,   305,   182,
     207,   205,   209,   298,   290,   209,   302,   209,   250,   230,
     250,   302,   209,   218,   253,   306,   242,   302,   209,    38,
      51,   206,   243,   252,   184,   184,   207,   258,   259,   258,
     207
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 321 "parser.y"
    { fix_incomplete();
						  check_statements((yyvsp[(1) - (1)].stmt_list), FALSE);
						  check_all_user_types((yyvsp[(1) - (1)].stmt_list));
						  write_header((yyvsp[(1) - (1)].stmt_list));
						  write_id_data((yyvsp[(1) - (1)].stmt_list));
						  write_proxies((yyvsp[(1) - (1)].stmt_list));
						  write_client((yyvsp[(1) - (1)].stmt_list));
						  write_server((yyvsp[(1) - (1)].stmt_list));
						  write_regscript((yyvsp[(1) - (1)].stmt_list));
						  write_dlldata((yyvsp[(1) - (1)].stmt_list));
						  write_local_stubs((yyvsp[(1) - (1)].stmt_list));
						;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 335 "parser.y"
    { (yyval.stmt_list) = NULL; ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 336 "parser.y"
    { push_namespace((yyvsp[(2) - (3)].str)); ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 337 "parser.y"
    { pop_namespace((yyvsp[(2) - (6)].str)); (yyval.stmt_list) = append_statements((yyvsp[(1) - (6)].stmt_list), (yyvsp[(5) - (6)].stmt_list)); ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 338 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_reference((yyvsp[(2) - (2)].type))); ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 339 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_type_decl((yyvsp[(2) - (2)].type))); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 340 "parser.y"
    { (yyval.stmt_list) = (yyvsp[(1) - (3)].stmt_list);
						  reg_type((yyvsp[(2) - (3)].type), (yyvsp[(2) - (3)].type)->name, current_namespace, 0);
						;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 343 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_type_decl((yyvsp[(2) - (2)].type)));
						  reg_type((yyvsp[(2) - (2)].type), (yyvsp[(2) - (2)].type)->name, current_namespace, 0);
						;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 346 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_module((yyvsp[(2) - (2)].type))); ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 347 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_library((yyvsp[(2) - (2)].typelib))); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 348 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), (yyvsp[(2) - (2)].statement)); ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 351 "parser.y"
    { (yyval.stmt_list) = NULL; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 352 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_reference((yyvsp[(2) - (2)].type))); ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 353 "parser.y"
    { push_namespace((yyvsp[(2) - (3)].str)); ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 354 "parser.y"
    { pop_namespace((yyvsp[(2) - (6)].str)); (yyval.stmt_list) = append_statements((yyvsp[(1) - (6)].stmt_list), (yyvsp[(5) - (6)].stmt_list)); ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 355 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_type_decl((yyvsp[(2) - (2)].type))); ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 356 "parser.y"
    { (yyval.stmt_list) = (yyvsp[(1) - (3)].stmt_list); reg_type((yyvsp[(2) - (3)].type), (yyvsp[(2) - (3)].type)->name, current_namespace, 0); ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 357 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_type_decl((yyvsp[(2) - (2)].type)));
						  reg_type((yyvsp[(2) - (2)].type), (yyvsp[(2) - (2)].type)->name, current_namespace, 0);
						;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 360 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_module((yyvsp[(2) - (2)].type))); ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 361 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), (yyvsp[(2) - (2)].statement)); ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 362 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_importlib((yyvsp[(2) - (2)].str))); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 363 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), make_statement_library((yyvsp[(2) - (2)].typelib))); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 366 "parser.y"
    { (yyval.stmt_list) = NULL; ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 367 "parser.y"
    { (yyval.stmt_list) = append_statement((yyvsp[(1) - (2)].stmt_list), (yyvsp[(2) - (2)].statement)); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 375 "parser.y"
    { (yyval.statement) = make_statement_cppquote((yyvsp[(1) - (1)].str)); ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 376 "parser.y"
    { (yyval.statement) = make_statement_type_decl((yyvsp[(1) - (2)].type)); ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 377 "parser.y"
    { (yyval.statement) = make_statement_declaration((yyvsp[(1) - (2)].var)); ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 378 "parser.y"
    { (yyval.statement) = make_statement_import((yyvsp[(1) - (1)].str)); ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 379 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (2)].statement); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 380 "parser.y"
    { (yyval.statement) = make_statement_pragma((yyvsp[(1) - (1)].str)); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 381 "parser.y"
    { (yyval.statement) = NULL; ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 385 "parser.y"
    {
                      int result;
                      (yyval.statement) = NULL;
                      result = do_warning((yyvsp[(3) - (6)].str), (yyvsp[(5) - (6)].warning_list));
                      if(!result)
                          error_loc("expected \"disable\" or \"enable\"\n");
                  ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 395 "parser.y"
    { (yyval.warning_list) = append_warning(NULL, (yyvsp[(1) - (1)].num)); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 396 "parser.y"
    { (yyval.warning_list) = append_warning((yyvsp[(1) - (2)].warning_list), (yyvsp[(2) - (2)].num)); ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 401 "parser.y"
    { (yyval.type) = type_new_enum((yyvsp[(2) - (2)].str), current_namespace, FALSE, NULL); ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 403 "parser.y"
    { (yyval.type) = type_new_struct((yyvsp[(2) - (2)].str), current_namespace, FALSE, NULL); ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 405 "parser.y"
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[(2) - (2)].str), FALSE, NULL); ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 406 "parser.y"
    { (yyval.type) = (yyvsp[(2) - (2)].type); (yyval.type)->attrs = check_enum_attrs((yyvsp[(1) - (2)].attr_list)); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 407 "parser.y"
    { (yyval.type) = (yyvsp[(2) - (2)].type); (yyval.type)->attrs = check_struct_attrs((yyvsp[(1) - (2)].attr_list)); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 408 "parser.y"
    { (yyval.type) = (yyvsp[(2) - (2)].type); (yyval.type)->attrs = check_union_attrs((yyvsp[(1) - (2)].attr_list)); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 411 "parser.y"
    { (yyval.str) = (yyvsp[(3) - (4)].str); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 413 "parser.y"
    { assert(yychar == YYEMPTY);
						  (yyval.import) = xmalloc(sizeof(struct _import_t));
						  (yyval.import)->name = (yyvsp[(2) - (3)].str);
						  (yyval.import)->import_performed = do_import((yyvsp[(2) - (3)].str));
						  if (!(yyval.import)->import_performed) yychar = aEOF;
						;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 421 "parser.y"
    { (yyval.str) = (yyvsp[(1) - (3)].import)->name;
						  if ((yyvsp[(1) - (3)].import)->import_performed) pop_import();
						  free((yyvsp[(1) - (3)].import));
						;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 428 "parser.y"
    { (yyval.str) = (yyvsp[(3) - (5)].str); if(!parse_only) add_importlib((yyvsp[(3) - (5)].str)); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 431 "parser.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 432 "parser.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 434 "parser.y"
    { (yyval.typelib) = make_library((yyvsp[(2) - (3)].str), check_library_attrs((yyvsp[(2) - (3)].str), (yyvsp[(1) - (3)].attr_list)));
						  if (!parse_only) start_typelib((yyval.typelib));
						;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 439 "parser.y"
    { (yyval.typelib) = (yyvsp[(1) - (4)].typelib);
						  (yyval.typelib)->stmts = (yyvsp[(2) - (4)].stmt_list);
						  if (!parse_only) end_typelib();
						;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 445 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 449 "parser.y"
    { check_arg_attrs((yyvsp[(1) - (1)].var)); (yyval.var_list) = append_var( NULL, (yyvsp[(1) - (1)].var) ); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 450 "parser.y"
    { check_arg_attrs((yyvsp[(3) - (3)].var)); (yyval.var_list) = append_var( (yyvsp[(1) - (3)].var_list), (yyvsp[(3) - (3)].var) ); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 454 "parser.y"
    { (yyval.var_list) = append_var( (yyvsp[(1) - (3)].var_list), make_var(strdup("...")) ); ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 458 "parser.y"
    { if ((yyvsp[(2) - (3)].declspec)->stgclass != STG_NONE && (yyvsp[(2) - (3)].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var((yyvsp[(1) - (3)].attr_list), (yyvsp[(2) - (3)].declspec), (yyvsp[(3) - (3)].declarator), TRUE);
						  free((yyvsp[(2) - (3)].declspec)); free((yyvsp[(3) - (3)].declarator));
						;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 463 "parser.y"
    { if ((yyvsp[(1) - (2)].declspec)->stgclass != STG_NONE && (yyvsp[(1) - (2)].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var(NULL, (yyvsp[(1) - (2)].declspec), (yyvsp[(2) - (2)].declarator), TRUE);
						  free((yyvsp[(1) - (2)].declspec)); free((yyvsp[(2) - (2)].declarator));
						;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 470 "parser.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr);
						  if (!(yyval.expr)->is_const)
						      error_loc("array dimension is not an integer constant\n");
						;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 474 "parser.y"
    { (yyval.expr) = make_expr(EXPR_VOID); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 475 "parser.y"
    { (yyval.expr) = make_expr(EXPR_VOID); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 478 "parser.y"
    { (yyval.attr_list) = NULL; ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 483 "parser.y"
    { (yyval.attr_list) = (yyvsp[(2) - (3)].attr_list); ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 486 "parser.y"
    { (yyval.attr_list) = append_attr( NULL, (yyvsp[(1) - (1)].attr) ); ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 487 "parser.y"
    { (yyval.attr_list) = append_attr( (yyvsp[(1) - (3)].attr_list), (yyvsp[(3) - (3)].attr) ); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 488 "parser.y"
    { (yyval.attr_list) = append_attr( (yyvsp[(1) - (4)].attr_list), (yyvsp[(4) - (4)].attr) ); ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 491 "parser.y"
    { (yyval.str_list) = append_str( NULL, (yyvsp[(1) - (1)].str) ); ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 492 "parser.y"
    { (yyval.str_list) = append_str( (yyvsp[(1) - (3)].str_list), (yyvsp[(3) - (3)].str) ); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 495 "parser.y"
    { (yyval.attr) = NULL; ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 496 "parser.y"
    { (yyval.attr) = make_attr(ATTR_AGGREGATABLE); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 497 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_ANNOTATION, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 498 "parser.y"
    { (yyval.attr) = make_attr(ATTR_APPOBJECT); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 499 "parser.y"
    { (yyval.attr) = make_attr(ATTR_ASYNC); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 500 "parser.y"
    { (yyval.attr) = make_attr(ATTR_AUTO_HANDLE); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 501 "parser.y"
    { (yyval.attr) = make_attr(ATTR_BINDABLE); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 502 "parser.y"
    { (yyval.attr) = make_attr(ATTR_BROADCAST); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 503 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_CALLAS, (yyvsp[(3) - (4)].var)); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 504 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_CASE, (yyvsp[(3) - (4)].expr_list)); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 505 "parser.y"
    { (yyval.attr) = make_attr(ATTR_CODE); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 506 "parser.y"
    { (yyval.attr) = make_attr(ATTR_COMMSTATUS); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 507 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 508 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); /* RPC_CONTEXT_HANDLE_DONT_SERIALIZE */ ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 509 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); /* RPC_CONTEXT_HANDLE_SERIALIZE */ ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 510 "parser.y"
    { (yyval.attr) = make_attr(ATTR_CONTROL); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 511 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DECODE); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 512 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DEFAULT); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 513 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DEFAULTBIND); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 514 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DEFAULTCOLLELEM); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 515 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_DEFAULTVALUE, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 516 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DEFAULTVTABLE); ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 517 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DISABLECONSISTENCYCHECK); ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 518 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DISPLAYBIND); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 519 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_DLLNAME, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 520 "parser.y"
    { (yyval.attr) = make_attr(ATTR_DUAL); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 521 "parser.y"
    { (yyval.attr) = make_attr(ATTR_ENABLEALLOCATE); ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 522 "parser.y"
    { (yyval.attr) = make_attr(ATTR_ENCODE); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 523 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_ENDPOINT, (yyvsp[(3) - (4)].str_list)); ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 524 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_ENTRY, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 525 "parser.y"
    { (yyval.attr) = make_attr(ATTR_EXPLICIT_HANDLE); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 526 "parser.y"
    { (yyval.attr) = make_attr(ATTR_FAULTSTATUS); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 527 "parser.y"
    { (yyval.attr) = make_attr(ATTR_FORCEALLOCATE); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 528 "parser.y"
    { (yyval.attr) = make_attr(ATTR_HANDLE); ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 529 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_HELPCONTEXT, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 530 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_HELPFILE, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 531 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_HELPSTRING, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 532 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_HELPSTRINGCONTEXT, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 533 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_HELPSTRINGDLL, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 534 "parser.y"
    { (yyval.attr) = make_attr(ATTR_HIDDEN); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 535 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_ID, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 536 "parser.y"
    { (yyval.attr) = make_attr(ATTR_IDEMPOTENT); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 537 "parser.y"
    { (yyval.attr) = make_attr(ATTR_IGNORE); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 538 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_IIDIS, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 539 "parser.y"
    { (yyval.attr) = make_attr(ATTR_IMMEDIATEBIND); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 540 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_IMPLICIT_HANDLE, (yyvsp[(3) - (4)].var)); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 541 "parser.y"
    { (yyval.attr) = make_attr(ATTR_IN); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 542 "parser.y"
    { (yyval.attr) = make_attr(ATTR_INPUTSYNC); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 543 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_LENGTHIS, (yyvsp[(3) - (4)].expr_list)); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 544 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_LIBLCID, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 545 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PARAMLCID); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 546 "parser.y"
    { (yyval.attr) = make_attr(ATTR_LICENSED); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 547 "parser.y"
    { (yyval.attr) = make_attr(ATTR_LOCAL); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 548 "parser.y"
    { (yyval.attr) = make_attr(ATTR_MAYBE); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 549 "parser.y"
    { (yyval.attr) = make_attr(ATTR_MESSAGE); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 550 "parser.y"
    { (yyval.attr) = make_attr(ATTR_NOCODE); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 551 "parser.y"
    { (yyval.attr) = make_attr(ATTR_NONBROWSABLE); ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 552 "parser.y"
    { (yyval.attr) = make_attr(ATTR_NONCREATABLE); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 553 "parser.y"
    { (yyval.attr) = make_attr(ATTR_NONEXTENSIBLE); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 554 "parser.y"
    { (yyval.attr) = make_attr(ATTR_NOTIFY); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 555 "parser.y"
    { (yyval.attr) = make_attr(ATTR_NOTIFYFLAG); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 556 "parser.y"
    { (yyval.attr) = make_attr(ATTR_OBJECT); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 557 "parser.y"
    { (yyval.attr) = make_attr(ATTR_ODL); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 558 "parser.y"
    { (yyval.attr) = make_attr(ATTR_OLEAUTOMATION); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 559 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_OPTIMIZE, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 560 "parser.y"
    { (yyval.attr) = make_attr(ATTR_OPTIONAL); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 561 "parser.y"
    { (yyval.attr) = make_attr(ATTR_OUT); ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 562 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PARTIALIGNORE); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 563 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_POINTERDEFAULT, (yyvsp[(3) - (4)].num)); ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 564 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_PROGID, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 565 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PROPGET); ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 566 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PROPPUT); ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 567 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PROPPUTREF); ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 568 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PROXY); ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 569 "parser.y"
    { (yyval.attr) = make_attr(ATTR_PUBLIC); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 571 "parser.y"
    { expr_list_t *list = append_expr( NULL, (yyvsp[(3) - (6)].expr) );
						  list = append_expr( list, (yyvsp[(5) - (6)].expr) );
						  (yyval.attr) = make_attrp(ATTR_RANGE, list); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 574 "parser.y"
    { (yyval.attr) = make_attr(ATTR_READONLY); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 575 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_REPRESENTAS, (yyvsp[(3) - (4)].type)); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 576 "parser.y"
    { (yyval.attr) = make_attr(ATTR_REQUESTEDIT); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 577 "parser.y"
    { (yyval.attr) = make_attr(ATTR_RESTRICTED); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 578 "parser.y"
    { (yyval.attr) = make_attr(ATTR_RETVAL); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 579 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_SIZEIS, (yyvsp[(3) - (4)].expr_list)); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 580 "parser.y"
    { (yyval.attr) = make_attr(ATTR_SOURCE); ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 581 "parser.y"
    { (yyval.attr) = make_attr(ATTR_STRICTCONTEXTHANDLE); ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 582 "parser.y"
    { (yyval.attr) = make_attr(ATTR_STRING); ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 583 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_SWITCHIS, (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 584 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_SWITCHTYPE, (yyvsp[(3) - (4)].type)); ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 585 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_TRANSMITAS, (yyvsp[(3) - (4)].type)); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 586 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_THREADING, (yyvsp[(3) - (4)].num)); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 587 "parser.y"
    { (yyval.attr) = make_attr(ATTR_UIDEFAULT); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 588 "parser.y"
    { (yyval.attr) = make_attr(ATTR_USESGETLASTERROR); ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 589 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_USERMARSHAL, (yyvsp[(3) - (4)].type)); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 590 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_UUID, (yyvsp[(3) - (4)].uuid)); ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 591 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_ASYNCUUID, (yyvsp[(3) - (4)].uuid)); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 592 "parser.y"
    { (yyval.attr) = make_attr(ATTR_V1ENUM); ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 593 "parser.y"
    { (yyval.attr) = make_attr(ATTR_VARARG); ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 594 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_VERSION, (yyvsp[(3) - (4)].num)); ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 595 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_VIPROGID, (yyvsp[(3) - (4)].str)); ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 596 "parser.y"
    { (yyval.attr) = make_attrp(ATTR_WIREMARSHAL, (yyvsp[(3) - (4)].type)); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 597 "parser.y"
    { (yyval.attr) = make_attrv(ATTR_POINTERTYPE, (yyvsp[(1) - (1)].num)); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 602 "parser.y"
    { if (!is_valid_uuid((yyvsp[(1) - (1)].str)))
						    error_loc("invalid UUID: %s\n", (yyvsp[(1) - (1)].str));
						  (yyval.uuid) = parse_uuid((yyvsp[(1) - (1)].str)); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 607 "parser.y"
    { (yyval.str) = xstrdup("__cdecl"); ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 608 "parser.y"
    { (yyval.str) = xstrdup("__fastcall"); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 609 "parser.y"
    { (yyval.str) = xstrdup("__pascal"); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 610 "parser.y"
    { (yyval.str) = xstrdup("__stdcall"); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 613 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 614 "parser.y"
    { (yyval.var_list) = append_var( (yyvsp[(1) - (2)].var_list), (yyvsp[(2) - (2)].var) ); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 617 "parser.y"
    { attr_t *a = make_attrp(ATTR_CASE, append_expr( NULL, (yyvsp[(2) - (4)].expr) ));
						  (yyval.var) = (yyvsp[(4) - (4)].var); if (!(yyval.var)) (yyval.var) = make_var(NULL);
						  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
						;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 621 "parser.y"
    { attr_t *a = make_attr(ATTR_DEFAULT);
						  (yyval.var) = (yyvsp[(3) - (3)].var); if (!(yyval.var)) (yyval.var) = make_var(NULL);
						  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
						;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 627 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 628 "parser.y"
    { (yyval.var_list) = (yyvsp[(1) - (2)].var_list); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 632 "parser.y"
    { if (!(yyvsp[(1) - (1)].var)->eval)
						    (yyvsp[(1) - (1)].var)->eval = make_exprl(EXPR_NUM, 0 /* default for first enum entry */);
                                                  (yyval.var_list) = append_var( NULL, (yyvsp[(1) - (1)].var) );
						;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 636 "parser.y"
    { if (!(yyvsp[(3) - (3)].var)->eval)
                                                  {
                                                    var_t *last = LIST_ENTRY( list_tail((yyval.var_list)), var_t, entry );
                                                    enum expr_type type = EXPR_NUM;
                                                    if (last->eval->type == EXPR_HEXNUM) type = EXPR_HEXNUM;
                                                    if (last->eval->cval + 1 < 0) type = EXPR_HEXNUM;
                                                    (yyvsp[(3) - (3)].var)->eval = make_exprl(type, last->eval->cval + 1);
                                                  }
                                                  (yyval.var_list) = append_var( (yyvsp[(1) - (3)].var_list), (yyvsp[(3) - (3)].var) );
						;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 648 "parser.y"
    { (yyval.var) = reg_const((yyvsp[(1) - (3)].var));
						  (yyval.var)->eval = (yyvsp[(3) - (3)].expr);
                                                  (yyval.var)->type = type_new_int(TYPE_BASIC_INT, 0);
						;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 652 "parser.y"
    { (yyval.var) = reg_const((yyvsp[(1) - (1)].var));
                                                  (yyval.var)->type = type_new_int(TYPE_BASIC_INT, 0);
						;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 657 "parser.y"
    { (yyval.type) = type_new_enum((yyvsp[(2) - (5)].str), current_namespace, TRUE, (yyvsp[(4) - (5)].var_list)); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 660 "parser.y"
    { (yyval.expr_list) = append_expr( NULL, (yyvsp[(1) - (1)].expr) ); ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 661 "parser.y"
    { (yyval.expr_list) = append_expr( (yyvsp[(1) - (3)].expr_list), (yyvsp[(3) - (3)].expr) ); ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 664 "parser.y"
    { (yyval.expr) = make_expr(EXPR_VOID); ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 668 "parser.y"
    { (yyval.expr) = make_exprl(EXPR_NUM, (yyvsp[(1) - (1)].num)); ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 669 "parser.y"
    { (yyval.expr) = make_exprl(EXPR_HEXNUM, (yyvsp[(1) - (1)].num)); ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 670 "parser.y"
    { (yyval.expr) = make_exprd(EXPR_DOUBLE, (yyvsp[(1) - (1)].dbl)); ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 671 "parser.y"
    { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 0); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 672 "parser.y"
    { (yyval.expr) = make_exprl(EXPR_NUM, 0); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 673 "parser.y"
    { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 1); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 674 "parser.y"
    { (yyval.expr) = make_exprs(EXPR_STRLIT, (yyvsp[(1) - (1)].str)); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 675 "parser.y"
    { (yyval.expr) = make_exprs(EXPR_WSTRLIT, (yyvsp[(1) - (1)].str)); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 676 "parser.y"
    { (yyval.expr) = make_exprs(EXPR_CHARCONST, (yyvsp[(1) - (1)].str)); ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 677 "parser.y"
    { (yyval.expr) = make_exprs(EXPR_IDENTIFIER, (yyvsp[(1) - (1)].str)); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 678 "parser.y"
    { (yyval.expr) = make_expr3(EXPR_COND, (yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr)); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 679 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_LOGOR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 680 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_LOGAND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 681 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_OR , (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 682 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_XOR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 683 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 684 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_EQUALITY, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 685 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_INEQUALITY, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 686 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_GTR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 687 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_LESS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 688 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_GTREQL, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 689 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_LESSEQL, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 690 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_SHL, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 691 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_SHR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 692 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_ADD, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 693 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_SUB, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 694 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_MOD, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 695 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_MUL, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 696 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_DIV, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 697 "parser.y"
    { (yyval.expr) = make_expr1(EXPR_LOGNOT, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 698 "parser.y"
    { (yyval.expr) = make_expr1(EXPR_NOT, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 699 "parser.y"
    { (yyval.expr) = make_expr1(EXPR_POS, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 700 "parser.y"
    { (yyval.expr) = make_expr1(EXPR_NEG, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 701 "parser.y"
    { (yyval.expr) = make_expr1(EXPR_ADDRESSOF, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 702 "parser.y"
    { (yyval.expr) = make_expr1(EXPR_PPTR, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 703 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_MEMBER, make_expr1(EXPR_PPTR, (yyvsp[(1) - (3)].expr)), make_exprs(EXPR_IDENTIFIER, (yyvsp[(3) - (3)].str))); ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 704 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_MEMBER, (yyvsp[(1) - (3)].expr), make_exprs(EXPR_IDENTIFIER, (yyvsp[(3) - (3)].str))); ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 706 "parser.y"
    { (yyval.expr) = make_exprt(EXPR_CAST, declare_var(NULL, (yyvsp[(2) - (5)].declspec), (yyvsp[(3) - (5)].declarator), 0), (yyvsp[(5) - (5)].expr)); free((yyvsp[(2) - (5)].declspec)); free((yyvsp[(3) - (5)].declarator)); ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 708 "parser.y"
    { (yyval.expr) = make_exprt(EXPR_SIZEOF, declare_var(NULL, (yyvsp[(3) - (5)].declspec), (yyvsp[(4) - (5)].declarator), 0), NULL); free((yyvsp[(3) - (5)].declspec)); free((yyvsp[(4) - (5)].declarator)); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 709 "parser.y"
    { (yyval.expr) = make_expr2(EXPR_ARRAY, (yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 710 "parser.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 713 "parser.y"
    { (yyval.expr_list) = append_expr( NULL, (yyvsp[(1) - (1)].expr) ); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 714 "parser.y"
    { (yyval.expr_list) = append_expr( (yyvsp[(1) - (3)].expr_list), (yyvsp[(3) - (3)].expr) ); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 717 "parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr);
						  if (!(yyval.expr)->is_const)
						      error_loc("expression is not an integer constant\n");
						;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 723 "parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr);
						  if (!(yyval.expr)->is_const && (yyval.expr)->type != EXPR_STRLIT && (yyval.expr)->type != EXPR_WSTRLIT)
						      error_loc("expression is not constant\n");
						;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 729 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 730 "parser.y"
    { (yyval.var_list) = append_var_list((yyvsp[(1) - (2)].var_list), (yyvsp[(2) - (2)].var_list)); ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 734 "parser.y"
    { const char *first = LIST_ENTRY(list_head((yyvsp[(3) - (4)].declarator_list)), declarator_t, entry)->var->name;
						  check_field_attrs(first, (yyvsp[(1) - (4)].attr_list));
						  (yyval.var_list) = set_var_types((yyvsp[(1) - (4)].attr_list), (yyvsp[(2) - (4)].declspec), (yyvsp[(3) - (4)].declarator_list));
						;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 738 "parser.y"
    { var_t *v = make_var(NULL);
						  v->type = (yyvsp[(2) - (3)].type); v->attrs = (yyvsp[(1) - (3)].attr_list);
						  (yyval.var_list) = append_var(NULL, v);
						;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 745 "parser.y"
    { (yyval.var) = (yyvsp[(1) - (2)].var); ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 746 "parser.y"
    { (yyval.var) = make_var(NULL); (yyval.var)->attrs = (yyvsp[(1) - (2)].attr_list); ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 749 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 750 "parser.y"
    { (yyval.var_list) = append_var( (yyvsp[(1) - (2)].var_list), (yyvsp[(2) - (2)].var) ); ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 754 "parser.y"
    { (yyval.var) = (yyvsp[(1) - (2)].var); ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 755 "parser.y"
    { (yyval.var) = NULL; ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 758 "parser.y"
    { (yyval.var) = declare_var(check_field_attrs((yyvsp[(3) - (3)].declarator)->var->name, (yyvsp[(1) - (3)].attr_list)),
						                (yyvsp[(2) - (3)].declspec), (yyvsp[(3) - (3)].declarator), FALSE);
						  free((yyvsp[(3) - (3)].declarator));
						;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 762 "parser.y"
    { var_t *v = make_var(NULL);
						  v->type = (yyvsp[(2) - (2)].type); v->attrs = (yyvsp[(1) - (2)].attr_list);
						  (yyval.var) = v;
						;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 768 "parser.y"
    { (yyval.var) = (yyvsp[(1) - (1)].var);
						  if (type_get_type((yyval.var)->type) != TYPE_FUNCTION)
						    error_loc("only methods may be declared inside the methods section of a dispinterface\n");
						  check_function_attrs((yyval.var)->name, (yyval.var)->attrs);
						;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 777 "parser.y"
    { (yyval.var) = declare_var((yyvsp[(1) - (3)].attr_list), (yyvsp[(2) - (3)].declspec), (yyvsp[(3) - (3)].declarator), FALSE);
						  free((yyvsp[(3) - (3)].declarator));
						;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 780 "parser.y"
    { (yyval.var) = declare_var(NULL, (yyvsp[(1) - (2)].declspec), (yyvsp[(2) - (2)].declarator), FALSE);
						  free((yyvsp[(2) - (2)].declarator));
						;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 785 "parser.y"
    { (yyval.var) = NULL; ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 789 "parser.y"
    { (yyval.str) = NULL; ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 790 "parser.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 791 "parser.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 794 "parser.y"
    { (yyval.var) = make_var((yyvsp[(1) - (1)].str)); ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 796 "parser.y"
    { (yyval.var) = make_var((yyvsp[(1) - (1)].str)); ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 799 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 800 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 802 "parser.y"
    { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[(2) - (2)].type)), -1); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 803 "parser.y"
    { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[(2) - (2)].type)), 1); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 804 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT, 1); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 805 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 806 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 807 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 808 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 809 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 816 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT, 0); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 817 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT16, 0); ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 818 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT8, 0); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 819 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT32, 0); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 820 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_HYPER, 0); ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 821 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT64, 0); ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 822 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_CHAR, 0); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 823 "parser.y"
    { (yyval.type) = type_new_int(TYPE_BASIC_INT3264, 0); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 826 "parser.y"
    { (yyval.type) = type_new_coclass((yyvsp[(2) - (2)].str)); ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 827 "parser.y"
    { (yyval.type) = find_type((yyvsp[(2) - (2)].str), NULL, 0);
						  if (type_get_type_detect_alias((yyval.type)) != TYPE_COCLASS)
						    error_loc("%s was not declared a coclass at %s:%d\n",
							      (yyvsp[(2) - (2)].str), (yyval.type)->loc_info.input_name,
							      (yyval.type)->loc_info.line_number);
						;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 835 "parser.y"
    { (yyval.type) = (yyvsp[(2) - (2)].type);
						  check_def((yyval.type));
						  (yyval.type)->attrs = check_coclass_attrs((yyvsp[(2) - (2)].type)->name, (yyvsp[(1) - (2)].attr_list));
						;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 842 "parser.y"
    { (yyval.type) = type_coclass_define((yyvsp[(1) - (5)].type), (yyvsp[(3) - (5)].ifref_list)); ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 845 "parser.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 848 "parser.y"
    { (yyval.ifref_list) = NULL; ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 849 "parser.y"
    { (yyval.ifref_list) = append_ifref( (yyvsp[(1) - (2)].ifref_list), (yyvsp[(2) - (2)].ifref) ); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 853 "parser.y"
    { (yyval.ifref) = make_ifref((yyvsp[(2) - (2)].type)); (yyval.ifref)->attrs = (yyvsp[(1) - (2)].attr_list); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 856 "parser.y"
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[(2) - (2)].str), current_namespace, 0); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 857 "parser.y"
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[(2) - (2)].str), current_namespace, 0); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 860 "parser.y"
    { attr_t *attrs;
						  (yyval.type) = (yyvsp[(2) - (2)].type);
						  check_def((yyval.type));
						  attrs = make_attr(ATTR_DISPINTERFACE);
						  (yyval.type)->attrs = append_attr( check_dispiface_attrs((yyvsp[(2) - (2)].type)->name, (yyvsp[(1) - (2)].attr_list)), attrs );
						  (yyval.type)->defined = TRUE;
						;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 869 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 870 "parser.y"
    { (yyval.var_list) = append_var( (yyvsp[(1) - (3)].var_list), (yyvsp[(2) - (3)].var) ); ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 873 "parser.y"
    { (yyval.var_list) = NULL; ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 874 "parser.y"
    { (yyval.var_list) = append_var( (yyvsp[(1) - (3)].var_list), (yyvsp[(2) - (3)].var) ); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 880 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (5)].type);
						  type_dispinterface_define((yyval.type), (yyvsp[(3) - (5)].var_list), (yyvsp[(4) - (5)].var_list));
						;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 884 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (5)].type);
						  type_dispinterface_define_from_iface((yyval.type), (yyvsp[(3) - (5)].type));
						;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 889 "parser.y"
    { (yyval.type) = NULL; ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 890 "parser.y"
    { (yyval.type) = find_type_or_error2((yyvsp[(2) - (2)].str), 0); ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 893 "parser.y"
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[(2) - (2)].str), current_namespace, 0); ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 894 "parser.y"
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[(2) - (2)].str), current_namespace, 0); ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 897 "parser.y"
    { (yyval.ifinfo).interface = (yyvsp[(2) - (2)].type);
						  (yyval.ifinfo).old_pointer_default = pointer_default;
						  if (is_attr((yyvsp[(1) - (2)].attr_list), ATTR_POINTERDEFAULT))
						    pointer_default = get_attrv((yyvsp[(1) - (2)].attr_list), ATTR_POINTERDEFAULT);
						  check_def((yyvsp[(2) - (2)].type));
						  (yyvsp[(2) - (2)].type)->attrs = check_iface_attrs((yyvsp[(2) - (2)].type)->name, (yyvsp[(1) - (2)].attr_list));
						  (yyvsp[(2) - (2)].type)->defined = TRUE;
						;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 908 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (6)].ifinfo).interface;
						  if((yyval.type) == (yyvsp[(2) - (6)].type))
						    error_loc("Interface can't inherit from itself\n");
						  type_interface_define((yyval.type), (yyvsp[(2) - (6)].type), (yyvsp[(4) - (6)].stmt_list));
						  pointer_default = (yyvsp[(1) - (6)].ifinfo).old_pointer_default;
						;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 918 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (8)].ifinfo).interface;
						  type_interface_define((yyval.type), find_type_or_error2((yyvsp[(3) - (8)].str), 0), (yyvsp[(6) - (8)].stmt_list));
						  pointer_default = (yyvsp[(1) - (8)].ifinfo).old_pointer_default;
						;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 922 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (2)].type); ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 926 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (2)].type); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 927 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (2)].type); ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 930 "parser.y"
    { (yyval.type) = type_new_module((yyvsp[(2) - (2)].str)); ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 931 "parser.y"
    { (yyval.type) = type_new_module((yyvsp[(2) - (2)].str)); ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 934 "parser.y"
    { (yyval.type) = (yyvsp[(2) - (2)].type);
						  (yyval.type)->attrs = check_module_attrs((yyvsp[(2) - (2)].type)->name, (yyvsp[(1) - (2)].attr_list));
						;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 940 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (5)].type);
                                                  type_module_define((yyval.type), (yyvsp[(3) - (5)].stmt_list));
						;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 946 "parser.y"
    { (yyval.stgclass) = STG_EXTERN; ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 947 "parser.y"
    { (yyval.stgclass) = STG_STATIC; ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 948 "parser.y"
    { (yyval.stgclass) = STG_REGISTER; ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 952 "parser.y"
    { (yyval.attr) = make_attr(ATTR_INLINE); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 956 "parser.y"
    { (yyval.attr) = make_attr(ATTR_CONST); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 959 "parser.y"
    { (yyval.attr_list) = NULL; ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 960 "parser.y"
    { (yyval.attr_list) = append_attr((yyvsp[(1) - (2)].attr_list), (yyvsp[(2) - (2)].attr)); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 963 "parser.y"
    { (yyval.declspec) = make_decl_spec((yyvsp[(1) - (2)].type), (yyvsp[(2) - (2)].declspec), NULL, NULL, STG_NONE); ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 965 "parser.y"
    { (yyval.declspec) = make_decl_spec((yyvsp[(2) - (3)].type), (yyvsp[(1) - (3)].declspec), (yyvsp[(3) - (3)].declspec), NULL, STG_NONE); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 968 "parser.y"
    { (yyval.declspec) = NULL; ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 973 "parser.y"
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[(2) - (2)].declspec), NULL, (yyvsp[(1) - (2)].attr), STG_NONE); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 974 "parser.y"
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[(2) - (2)].declspec), NULL, (yyvsp[(1) - (2)].attr), STG_NONE); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 975 "parser.y"
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[(2) - (2)].declspec), NULL, NULL, (yyvsp[(1) - (2)].stgclass)); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 980 "parser.y"
    { (yyval.declarator) = (yyvsp[(3) - (3)].declarator); (yyval.declarator)->type = append_ptrchain_type((yyval.declarator)->type, type_new_pointer(pointer_default, NULL, (yyvsp[(2) - (3)].attr_list))); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 981 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (2)].declarator); if ((yyval.declarator)->func_type) (yyval.declarator)->func_type->attrs = append_attr((yyval.declarator)->func_type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str)));
						           else if ((yyval.declarator)->type) (yyval.declarator)->type->attrs = append_attr((yyval.declarator)->type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str))); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 987 "parser.y"
    { (yyval.declarator) = make_declarator((yyvsp[(1) - (1)].var)); ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 988 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (3)].declarator); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 989 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (2)].declarator); (yyval.declarator)->array = append_array((yyval.declarator)->array, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 990 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (4)].declarator);
						  (yyval.declarator)->func_type = append_ptrchain_type((yyval.declarator)->type, type_new_function((yyvsp[(3) - (4)].var_list)));
						  (yyval.declarator)->type = NULL;
						;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 999 "parser.y"
    { (yyval.declarator) = (yyvsp[(3) - (3)].declarator); (yyval.declarator)->type = append_ptrchain_type((yyval.declarator)->type, type_new_pointer(pointer_default, NULL, (yyvsp[(2) - (3)].attr_list))); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1000 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (2)].declarator); if ((yyval.declarator)->func_type) (yyval.declarator)->func_type->attrs = append_attr((yyval.declarator)->func_type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str)));
						           else if ((yyval.declarator)->type) (yyval.declarator)->type->attrs = append_attr((yyval.declarator)->type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str))); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1008 "parser.y"
    { (yyval.declarator) = (yyvsp[(3) - (3)].declarator); (yyval.declarator)->type = append_ptrchain_type((yyval.declarator)->type, type_new_pointer(pointer_default, NULL, (yyvsp[(2) - (3)].attr_list))); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1009 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (2)].declarator); if ((yyval.declarator)->func_type) (yyval.declarator)->func_type->attrs = append_attr((yyval.declarator)->func_type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str)));
						           else if ((yyval.declarator)->type) (yyval.declarator)->type->attrs = append_attr((yyval.declarator)->type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str))); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1014 "parser.y"
    { (yyval.declarator) = make_declarator(NULL); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1020 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (3)].declarator); ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1021 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (2)].declarator); (yyval.declarator)->array = append_array((yyval.declarator)->array, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1022 "parser.y"
    { (yyval.declarator) = make_declarator(NULL); (yyval.declarator)->array = append_array((yyval.declarator)->array, (yyvsp[(1) - (1)].expr)); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1024 "parser.y"
    { (yyval.declarator) = make_declarator(NULL);
						  (yyval.declarator)->func_type = append_ptrchain_type((yyval.declarator)->type, type_new_function((yyvsp[(2) - (3)].var_list)));
						  (yyval.declarator)->type = NULL;
						;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1029 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (4)].declarator);
						  (yyval.declarator)->func_type = append_ptrchain_type((yyval.declarator)->type, type_new_function((yyvsp[(3) - (4)].var_list)));
						  (yyval.declarator)->type = NULL;
						;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1038 "parser.y"
    { (yyval.declarator) = (yyvsp[(3) - (3)].declarator); (yyval.declarator)->type = append_ptrchain_type((yyval.declarator)->type, type_new_pointer(pointer_default, NULL, (yyvsp[(2) - (3)].attr_list))); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1039 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (2)].declarator); (yyval.declarator)->type->attrs = append_attr((yyval.declarator)->type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str))); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1046 "parser.y"
    { (yyval.declarator) = (yyvsp[(3) - (3)].declarator); (yyval.declarator)->type = append_ptrchain_type((yyval.declarator)->type, type_new_pointer(pointer_default, NULL, (yyvsp[(2) - (3)].attr_list))); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1047 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (2)].declarator); (yyval.declarator)->type->attrs = append_attr((yyval.declarator)->type->attrs, make_attrp(ATTR_CALLCONV, (yyvsp[(1) - (2)].str))); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1051 "parser.y"
    { (yyval.declarator) = make_declarator(NULL); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1059 "parser.y"
    { (yyval.declarator) = make_declarator((yyvsp[(1) - (1)].var)); ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1060 "parser.y"
    { (yyval.declarator) = (yyvsp[(2) - (3)].declarator); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1061 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (2)].declarator); (yyval.declarator)->array = append_array((yyval.declarator)->array, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1062 "parser.y"
    { (yyval.declarator) = make_declarator(NULL); (yyval.declarator)->array = append_array((yyval.declarator)->array, (yyvsp[(1) - (1)].expr)); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1064 "parser.y"
    { (yyval.declarator) = make_declarator(NULL);
						  (yyval.declarator)->func_type = append_ptrchain_type((yyval.declarator)->type, type_new_function((yyvsp[(2) - (3)].var_list)));
						  (yyval.declarator)->type = NULL;
						;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1069 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (4)].declarator);
						  (yyval.declarator)->func_type = append_ptrchain_type((yyval.declarator)->type, type_new_function((yyvsp[(3) - (4)].var_list)));
						  (yyval.declarator)->type = NULL;
						;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 1076 "parser.y"
    { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[(1) - (1)].declarator) ); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1077 "parser.y"
    { (yyval.declarator_list) = append_declarator( (yyvsp[(1) - (3)].declarator_list), (yyvsp[(3) - (3)].declarator) ); ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1080 "parser.y"
    { (yyval.expr) = NULL; ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1081 "parser.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1084 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (2)].declarator); (yyval.declarator)->bits = (yyvsp[(2) - (2)].expr);
						  if (!(yyval.declarator)->bits && !(yyval.declarator)->var->name)
						    error_loc("unnamed fields are not allowed\n");
						;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1091 "parser.y"
    { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[(1) - (1)].declarator) ); ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1093 "parser.y"
    { (yyval.declarator_list) = append_declarator( (yyvsp[(1) - (3)].declarator_list), (yyvsp[(3) - (3)].declarator) ); ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1097 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (1)].declarator); ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 1098 "parser.y"
    { (yyval.declarator) = (yyvsp[(1) - (3)].declarator); (yyvsp[(1) - (3)].declarator)->var->eval = (yyvsp[(3) - (3)].expr); ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1102 "parser.y"
    { (yyval.num) = THREADING_APARTMENT; ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1103 "parser.y"
    { (yyval.num) = THREADING_NEUTRAL; ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 1104 "parser.y"
    { (yyval.num) = THREADING_SINGLE; ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1105 "parser.y"
    { (yyval.num) = THREADING_FREE; ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1106 "parser.y"
    { (yyval.num) = THREADING_BOTH; ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1110 "parser.y"
    { (yyval.num) = RPC_FC_RP; ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1111 "parser.y"
    { (yyval.num) = RPC_FC_UP; ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1112 "parser.y"
    { (yyval.num) = RPC_FC_FP; ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1115 "parser.y"
    { (yyval.type) = type_new_struct((yyvsp[(2) - (5)].str), current_namespace, TRUE, (yyvsp[(4) - (5)].var_list)); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1118 "parser.y"
    { (yyval.type) = type_new_void(); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1119 "parser.y"
    { (yyval.type) = find_type_or_error((yyvsp[(1) - (1)].str), 0); ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1120 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1121 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1122 "parser.y"
    { (yyval.type) = type_new_enum((yyvsp[(2) - (2)].str), current_namespace, FALSE, NULL); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1123 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1124 "parser.y"
    { (yyval.type) = type_new_struct((yyvsp[(2) - (2)].str), current_namespace, FALSE, NULL); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1125 "parser.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1126 "parser.y"
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[(2) - (2)].str), FALSE, NULL); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1127 "parser.y"
    { (yyval.type) = make_safearray((yyvsp[(3) - (4)].type)); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1131 "parser.y"
    { (yyvsp[(1) - (5)].attr_list) = append_attribs((yyvsp[(1) - (5)].attr_list), (yyvsp[(3) - (5)].attr_list));
						  reg_typedefs((yyvsp[(4) - (5)].declspec), (yyvsp[(5) - (5)].declarator_list), check_typedef_attrs((yyvsp[(1) - (5)].attr_list)));
						  (yyval.statement) = make_statement_typedef((yyvsp[(5) - (5)].declarator_list));
						;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1138 "parser.y"
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[(2) - (5)].str), TRUE, (yyvsp[(4) - (5)].var_list)); ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1141 "parser.y"
    { (yyval.type) = type_new_encapsulated_union((yyvsp[(2) - (10)].str), (yyvsp[(5) - (10)].var), (yyvsp[(7) - (10)].var), (yyvsp[(9) - (10)].var_list)); ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1145 "parser.y"
    { (yyval.num) = MAKEVERSION((yyvsp[(1) - (1)].num), 0); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1146 "parser.y"
    { (yyval.num) = MAKEVERSION((yyvsp[(1) - (3)].num), (yyvsp[(3) - (3)].num)); ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1147 "parser.y"
    { (yyval.num) = (yyvsp[(1) - (1)].num); ;}
    break;



/* Line 1455 of yacc.c  */
#line 5625 "parser.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1150 "parser.y"


static void decl_builtin_basic(const char *name, enum type_basic_type type)
{
  type_t *t = type_new_basic(type);
  reg_type(t, name, NULL, 0);
}

static void decl_builtin_alias(const char *name, type_t *t)
{
  reg_type(type_new_alias(t, name), name, NULL, 0);
}

void init_types(void)
{
  decl_builtin_basic("byte", TYPE_BASIC_BYTE);
  decl_builtin_basic("wchar_t", TYPE_BASIC_WCHAR);
  decl_builtin_basic("float", TYPE_BASIC_FLOAT);
  decl_builtin_basic("double", TYPE_BASIC_DOUBLE);
  decl_builtin_basic("error_status_t", TYPE_BASIC_ERROR_STATUS_T);
  decl_builtin_basic("handle_t", TYPE_BASIC_HANDLE);
  decl_builtin_alias("boolean", type_new_basic(TYPE_BASIC_BYTE));
}

static str_list_t *append_str(str_list_t *list, char *str)
{
    struct str_list_entry_t *entry;

    if (!str) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->str = str;
    list_add_tail( list, &entry->entry );
    return list;
}

static attr_list_t *append_attr(attr_list_t *list, attr_t *attr)
{
    attr_t *attr_existing;
    if (!attr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    LIST_FOR_EACH_ENTRY(attr_existing, list, attr_t, entry)
        if (attr_existing->type == attr->type)
        {
            parser_warning("duplicate attribute %s\n", get_attr_display_name(attr->type));
            /* use the last attribute, like MIDL does */
            list_remove(&attr_existing->entry);
            break;
        }
    list_add_tail( list, &attr->entry );
    return list;
}

static attr_list_t *move_attr(attr_list_t *dst, attr_list_t *src, enum attr_type type)
{
  attr_t *attr;
  if (!src) return dst;
  LIST_FOR_EACH_ENTRY(attr, src, attr_t, entry)
    if (attr->type == type)
    {
      list_remove(&attr->entry);
      return append_attr(dst, attr);
    }
  return dst;
}

static attr_list_t *append_attr_list(attr_list_t *new_list, attr_list_t *old_list)
{
  struct list *entry;

  if (!old_list) return new_list;

  while ((entry = list_head(old_list)))
  {
    attr_t *attr = LIST_ENTRY(entry, attr_t, entry);
    list_remove(entry);
    new_list = append_attr(new_list, attr);
  }
  return new_list;
}

static attr_list_t *dupattrs(const attr_list_t *list)
{
  attr_list_t *new_list;
  const attr_t *attr;

  if (!list) return NULL;

  new_list = xmalloc( sizeof(*list) );
  list_init( new_list );
  LIST_FOR_EACH_ENTRY(attr, list, const attr_t, entry)
  {
    attr_t *new_attr = xmalloc(sizeof(*new_attr));
    *new_attr = *attr;
    list_add_tail(new_list, &new_attr->entry);
  }
  return new_list;
}

static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right, attr_t *attr, enum storage_class stgclass)
{
  decl_spec_t *declspec = left ? left : right;
  if (!declspec)
  {
    declspec = xmalloc(sizeof(*declspec));
    declspec->type = NULL;
    declspec->attrs = NULL;
    declspec->stgclass = STG_NONE;
  }
  declspec->type = type;
  if (left && declspec != left)
  {
    declspec->attrs = append_attr_list(declspec->attrs, left->attrs);
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = left->stgclass;
    else if (left->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    assert(!left->type);
    free(left);
  }
  if (right && declspec != right)
  {
    declspec->attrs = append_attr_list(declspec->attrs, right->attrs);
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = right->stgclass;
    else if (right->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    assert(!right->type);
    free(right);
  }

  declspec->attrs = append_attr(declspec->attrs, attr);
  if (declspec->stgclass == STG_NONE)
    declspec->stgclass = stgclass;
  else if (stgclass != STG_NONE)
    error_loc("only one storage class can be specified\n");

  /* apply attributes to type */
  if (type && declspec->attrs)
  {
    attr_list_t *attrs;
    declspec->type = duptype(type, 1);
    attrs = dupattrs(type->attrs);
    declspec->type->attrs = append_attr_list(attrs, declspec->attrs);
    declspec->attrs = NULL;
  }

  return declspec;
}

static attr_t *make_attr(enum attr_type type)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.ival = 0;
  return a;
}

static attr_t *make_attrv(enum attr_type type, unsigned int val)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.ival = val;
  return a;
}

static attr_t *make_attrp(enum attr_type type, void *val)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.pval = val;
  return a;
}

static expr_list_t *append_expr(expr_list_t *list, expr_t *expr)
{
    if (!expr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &expr->entry );
    return list;
}

static array_dims_t *append_array(array_dims_t *list, expr_t *expr)
{
    if (!expr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &expr->entry );
    return list;
}

static struct list type_pool = LIST_INIT(type_pool);
typedef struct
{
  type_t data;
  struct list link;
} type_pool_node_t;

type_t *alloc_type(void)
{
  type_pool_node_t *node = xmalloc(sizeof *node);
  list_add_tail(&type_pool, &node->link);
  return &node->data;
}

void set_all_tfswrite(int val)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.tfswrite = val;
}

void clear_all_offsets(void)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.typestring_offset = node->data.ptrdesc = 0;
}

static void type_function_add_head_arg(type_t *type, var_t *arg)
{
    if (!type->details.function->args)
    {
        type->details.function->args = xmalloc( sizeof(*type->details.function->args) );
        list_init( type->details.function->args );
    }
    list_add_head( type->details.function->args, &arg->entry );
}

static int is_allowed_range_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_INT3264:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_WCHAR:
        case TYPE_BASIC_HYPER:
            return TRUE;
        case TYPE_BASIC_FLOAT:
        case TYPE_BASIC_DOUBLE:
        case TYPE_BASIC_ERROR_STATUS_T:
        case TYPE_BASIC_HANDLE:
            return FALSE;
        }
        return FALSE;
    default:
        return FALSE;
    }
}

static type_t *append_ptrchain_type(type_t *ptrchain, type_t *type)
{
  type_t *ptrchain_type;
  if (!ptrchain)
    return type;
  for (ptrchain_type = ptrchain; type_pointer_get_ref(ptrchain_type); ptrchain_type = type_pointer_get_ref(ptrchain_type))
    ;
  assert(ptrchain_type->type_type == TYPE_POINTER);
  ptrchain_type->details.pointer.ref = type;
  return ptrchain;
}

static warning_list_t *append_warning(warning_list_t *list, int num)
{
    warning_t *entry;

    if(!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->num = num;
    list_add_tail( list, &entry->entry );
    return list;
}

static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, const declarator_t *decl,
                       int top)
{
  var_t *v = decl->var;
  expr_list_t *sizes = get_attrp(attrs, ATTR_SIZEIS);
  expr_list_t *lengs = get_attrp(attrs, ATTR_LENGTHIS);
  int sizeless;
  expr_t *dim;
  type_t **ptype;
  array_dims_t *arr = decl ? decl->array : NULL;
  type_t *func_type = decl ? decl->func_type : NULL;
  type_t *type = decl_spec->type;

  if (is_attr(type->attrs, ATTR_INLINE))
  {
    if (!func_type)
      error_loc("inline attribute applied to non-function type\n");
    else
    {
      type_t *t;
      /* move inline attribute from return type node to function node */
      for (t = func_type; is_ptr(t); t = type_pointer_get_ref(t))
        ;
      t->attrs = move_attr(t->attrs, type->attrs, ATTR_INLINE);
    }
  }

  /* add type onto the end of the pointers in pident->type */
  v->type = append_ptrchain_type(decl ? decl->type : NULL, type);
  v->stgclass = decl_spec->stgclass;
  v->attrs = attrs;

  /* check for pointer attribute being applied to non-pointer, non-array
   * type */
  if (!arr)
  {
    int ptr_attr = get_attrv(v->attrs, ATTR_POINTERTYPE);
    const type_t *ptr = NULL;
    /* pointer attributes on the left side of the type belong to the function
     * pointer, if one is being declared */
    type_t **pt = func_type ? &func_type : &v->type;
    for (ptr = *pt; ptr && !ptr_attr; )
    {
      ptr_attr = get_attrv(ptr->attrs, ATTR_POINTERTYPE);
      if (!ptr_attr && type_is_alias(ptr))
        ptr = type_alias_get_aliasee(ptr);
      else
        break;
    }
    if (is_ptr(ptr))
    {
      if (ptr_attr && ptr_attr != RPC_FC_UP &&
          type_get_type(type_pointer_get_ref(ptr)) == TYPE_INTERFACE)
          warning_loc_info(&v->loc_info,
                           "%s: pointer attribute applied to interface "
                           "pointer type has no effect\n", v->name);
      if (!ptr_attr && top && (*pt)->details.pointer.def_fc != RPC_FC_RP)
      {
        /* FIXME: this is a horrible hack to cope with the issue that we
         * store an offset to the typeformat string in the type object, but
         * two typeformat strings may be written depending on whether the
         * pointer is a toplevel parameter or not */
        *pt = duptype(*pt, 1);
      }
    }
    else if (ptr_attr)
       error_loc("%s: pointer attribute applied to non-pointer type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_STRING))
  {
    type_t *t = type;

    if (!is_ptr(v->type) && !arr)
      error_loc("'%s': [string] attribute applied to non-pointer, non-array type\n",
                v->name);

    while (is_ptr(t))
      t = type_pointer_get_ref(t);

    if (type_get_type(t) != TYPE_BASIC &&
        (get_basic_fc(t) != RPC_FC_CHAR &&
         get_basic_fc(t) != RPC_FC_BYTE &&
         get_basic_fc(t) != RPC_FC_WCHAR))
    {
      error_loc("'%s': [string] attribute is only valid on 'char', 'byte', or 'wchar_t' pointers and arrays\n",
                v->name);
    }
  }

  if (is_attr(v->attrs, ATTR_V1ENUM))
  {
    if (type_get_type_detect_alias(v->type) != TYPE_ENUM)
      error_loc("'%s': [v1_enum] attribute applied to non-enum type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_RANGE) && !is_allowed_range_type(v->type))
    error_loc("'%s': [range] attribute applied to non-integer type\n",
              v->name);

  ptype = &v->type;
  sizeless = FALSE;
  if (arr) LIST_FOR_EACH_ENTRY_REV(dim, arr, expr_t, entry)
  {
    if (sizeless)
      error_loc("%s: only the first array dimension can be unspecified\n", v->name);

    if (dim->is_const)
    {
      if (dim->cval <= 0)
        error_loc("%s: array dimension must be positive\n", v->name);

      /* FIXME: should use a type_memsize that allows us to pass in a pointer size */
      if (0)
      {
        unsigned int size = type_memsize(v->type);

        if (0xffffffffu / size < dim->cval)
          error_loc("%s: total array size is too large\n", v->name);
      }
    }
    else
      sizeless = TRUE;

    *ptype = type_new_array(NULL, *ptype, FALSE,
                            dim->is_const ? dim->cval : 0,
                            dim->is_const ? NULL : dim, NULL,
                            pointer_default);
  }

  ptype = &v->type;
  if (sizes) LIST_FOR_EACH_ENTRY(dim, sizes, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        if (!type_array_get_conformance(*ptype) ||
            type_array_get_conformance(*ptype)->type != EXPR_VOID)
          error_loc("%s: cannot specify size_is for an already sized array\n", v->name);
        else
          *ptype = type_new_array((*ptype)->name,
                                  type_array_get_element(*ptype), FALSE,
                                  0, dim, NULL, 0);
      }
      else if (is_ptr(*ptype))
        *ptype = type_new_array((*ptype)->name, type_pointer_get_ref(*ptype), TRUE,
                                0, dim, NULL, pointer_default);
      else
        error_loc("%s: size_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem;
    else
      error_loc("%s: too many expressions in size_is attribute\n", v->name);
  }

  ptype = &v->type;
  if (lengs) LIST_FOR_EACH_ENTRY(dim, lengs, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        *ptype = type_new_array((*ptype)->name,
                                type_array_get_element(*ptype),
                                type_array_is_decl_as_ptr(*ptype),
                                type_array_get_dim(*ptype),
                                type_array_get_conformance(*ptype),
                                dim, type_array_get_ptr_default_fc(*ptype));
      }
      else
        error_loc("%s: length_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem;
    else
      error_loc("%s: too many expressions in length_is attribute\n", v->name);
  }

  /* v->type is currently pointing to the type on the left-side of the
   * declaration, so we need to fix this up so that it is the return type of the
   * function and make v->type point to the function side of the declaration */
  if (func_type)
  {
    type_t *ft, *t;
    type_t *return_type = v->type;
    v->type = func_type;
    for (ft = v->type; is_ptr(ft); ft = type_pointer_get_ref(ft))
      ;
    assert(type_get_type_detect_alias(ft) == TYPE_FUNCTION);
    ft->details.function->retval = make_var(xstrdup("_RetVal"));
    ft->details.function->retval->type = return_type;
    /* move calling convention attribute, if present, from pointer nodes to
     * function node */
    for (t = v->type; is_ptr(t); t = type_pointer_get_ref(t))
      ft->attrs = move_attr(ft->attrs, t->attrs, ATTR_CALLCONV);
  }
  else
  {
    type_t *t;
    for (t = v->type; is_ptr(t); t = type_pointer_get_ref(t))
      if (is_attr(t->attrs, ATTR_CALLCONV))
        error_loc("calling convention applied to non-function-pointer type\n");
  }

  if (decl->bits)
    v->type = type_new_bitfield(v->type, decl->bits);

  return v;
}

static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls)
{
  declarator_t *decl, *next;
  var_list_t *var_list = NULL;

  LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
  {
    var_t *var = declare_var(attrs, decl_spec, decl, 0);
    var_list = append_var(var_list, var);
    free(decl);
  }
  free(decl_spec);
  return var_list;
}

static ifref_list_t *append_ifref(ifref_list_t *list, ifref_t *iface)
{
    if (!iface) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &iface->entry );
    return list;
}

static ifref_t *make_ifref(type_t *iface)
{
  ifref_t *l = xmalloc(sizeof(ifref_t));
  l->iface = iface;
  l->attrs = NULL;
  return l;
}

var_list_t *append_var(var_list_t *list, var_t *var)
{
    if (!var) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &var->entry );
    return list;
}

static var_list_t *append_var_list(var_list_t *list, var_list_t *vars)
{
    if (!vars) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_move_tail( list, vars );
    return list;
}

var_t *make_var(char *name)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  v->type = NULL;
  v->attrs = NULL;
  v->eval = NULL;
  v->stgclass = STG_NONE;
  init_loc_info(&v->loc_info);
  return v;
}

static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *d)
{
  if (!d) return list;
  if (!list) {
    list = xmalloc(sizeof(*list));
    list_init(list);
  }
  list_add_tail(list, &d->entry);
  return list;
}

static declarator_t *make_declarator(var_t *var)
{
  declarator_t *d = xmalloc(sizeof(*d));
  d->var = var ? var : make_var(NULL);
  d->type = NULL;
  d->func_type = NULL;
  d->array = NULL;
  d->bits = NULL;
  return d;
}

static type_t *make_safearray(type_t *type)
{
  return type_new_array(NULL, type_new_alias(type, "SAFEARRAY"), TRUE, 0,
                        NULL, NULL, RPC_FC_RP);
}

static typelib_t *make_library(const char *name, const attr_list_t *attrs)
{
    typelib_t *typelib = xmalloc(sizeof(*typelib));
    typelib->name = xstrdup(name);
    typelib->attrs = attrs;
    list_init( &typelib->importlibs );
    return typelib;
}

static int hash_ident(const char *name)
{
  const char *p = name;
  int sum = 0;
  /* a simple sum hash is probably good enough */
  while (*p) {
    sum += *p;
    p++;
  }
  return sum & (HASHMAX-1);
}

/***** type repository *****/

static struct namespace *find_sub_namespace(struct namespace *namespace, const char *name)
{
  struct namespace *cur;

  LIST_FOR_EACH_ENTRY(cur, &namespace->children, struct namespace, entry) {
    if(!strcmp(cur->name, name))
      return cur;
  }

  return NULL;
}

static void push_namespace(const char *name)
{
  struct namespace *namespace;

  namespace = find_sub_namespace(current_namespace, name);
  if(!namespace) {
    namespace = xmalloc(sizeof(*namespace));
    namespace->name = xstrdup(name);
    namespace->parent = current_namespace;
    list_add_tail(&current_namespace->children, &namespace->entry);
    list_init(&namespace->children);
    memset(namespace->type_hash, 0, sizeof(namespace->type_hash));
  }

  current_namespace = namespace;
}

static void pop_namespace(const char *name)
{
  assert(!strcmp(current_namespace->name, name) && current_namespace->parent);
  current_namespace = current_namespace->parent;
}

struct rtype {
  const char *name;
  type_t *type;
  int t;
  struct rtype *next;
};

type_t *reg_type(type_t *type, const char *name, struct namespace *namespace, int t)
{
  struct rtype *nt;
  int hash;
  if (!name) {
    error_loc("registering named type without name\n");
    return type;
  }
  if (!namespace)
    namespace = &global_namespace;
  hash = hash_ident(name);
  nt = xmalloc(sizeof(struct rtype));
  nt->name = name;
  if (is_global_namespace(namespace))
    type->c_name = name;
  else
    type->c_name = format_namespace(namespace, "__x_", "_C", name);
  nt->type = type;
  nt->t = t;
  nt->next = namespace->type_hash[hash];
  namespace->type_hash[hash] = nt;
  if ((t == tsSTRUCT || t == tsUNION))
    fix_incomplete_types(type);
  return type;
}

static int is_incomplete(const type_t *t)
{
  return !t->defined &&
    (type_get_type_detect_alias(t) == TYPE_STRUCT ||
     type_get_type_detect_alias(t) == TYPE_UNION ||
     type_get_type_detect_alias(t) == TYPE_ENCAPSULATED_UNION);
}

void add_incomplete(type_t *t)
{
  struct typenode *tn = xmalloc(sizeof *tn);
  tn->type = t;
  list_add_tail(&incomplete_types, &tn->entry);
}

static void fix_type(type_t *t)
{
  if (type_is_alias(t) && is_incomplete(t)) {
    type_t *ot = type_alias_get_aliasee(t);
    fix_type(ot);
    if (type_get_type_detect_alias(ot) == TYPE_STRUCT ||
        type_get_type_detect_alias(ot) == TYPE_UNION ||
        type_get_type_detect_alias(ot) == TYPE_ENCAPSULATED_UNION)
      t->details.structure = ot->details.structure;
    t->defined = ot->defined;
  }
}

static void fix_incomplete(void)
{
  struct typenode *tn, *next;

  LIST_FOR_EACH_ENTRY_SAFE(tn, next, &incomplete_types, struct typenode, entry) {
    fix_type(tn->type);
    list_remove(&tn->entry);
    free(tn);
  }
}

static void fix_incomplete_types(type_t *complete_type)
{
  struct typenode *tn, *next;

  LIST_FOR_EACH_ENTRY_SAFE(tn, next, &incomplete_types, struct typenode, entry)
  {
    if (type_is_equal(complete_type, tn->type))
    {
      tn->type->details.structure = complete_type->details.structure;
      list_remove(&tn->entry);
      free(tn);
    }
  }
}

static type_t *reg_typedefs(decl_spec_t *decl_spec, declarator_list_t *decls, attr_list_t *attrs)
{
  const declarator_t *decl;
  type_t *type = decl_spec->type;

  if (is_attr(attrs, ATTR_UUID) && !is_attr(attrs, ATTR_PUBLIC))
    attrs = append_attr( attrs, make_attr(ATTR_PUBLIC) );

  /* We must generate names for tagless enum, struct or union.
     Typedef-ing a tagless enum, struct or union means we want the typedef
     to be included in a library hence the public attribute.  */
  if (type_get_type_detect_alias(type) == TYPE_ENUM ||
      type_get_type_detect_alias(type) == TYPE_STRUCT ||
      type_get_type_detect_alias(type) == TYPE_UNION ||
      type_get_type_detect_alias(type) == TYPE_ENCAPSULATED_UNION)
  {
    if (!type->name)
      type->name = gen_name();

    /* replace existing attributes when generating a typelib */
    if (do_typelib)
        type->attrs = attrs;
  }

  LIST_FOR_EACH_ENTRY( decl, decls, const declarator_t, entry )
  {

    if (decl->var->name) {
      type_t *cur;
      var_t *name;

      cur = find_type(decl->var->name, current_namespace, 0);

      /*
       * MIDL allows shadowing types that are declared in imported files.
       * We don't throw an error in this case and instead add a new type
       * (which is earlier on the list in hash table, so it will be used
       * instead of shadowed type).
       *
       * FIXME: We may consider string separated type tables for each input
       *        for cleaner solution.
       */
      if (cur && input_name == cur->loc_info.input_name)
          error_loc("%s: redefinition error; original definition was at %s:%d\n",
                    cur->name, cur->loc_info.input_name,
                    cur->loc_info.line_number);

      name = declare_var(attrs, decl_spec, decl, 0);
      cur = type_new_alias(name->type, name->name);
      cur->attrs = attrs;

      if (is_incomplete(cur))
        add_incomplete(cur);
      reg_type(cur, cur->name, current_namespace, 0);
    }
  }
  return type;
}

type_t *find_type(const char *name, struct namespace *namespace, int t)
{
  struct rtype *cur;

  if(namespace && namespace != &global_namespace) {
    for(cur = namespace->type_hash[hash_ident(name)]; cur; cur = cur->next) {
      if(cur->t == t && !strcmp(cur->name, name))
        return cur->type;
    }
  }
  for(cur = global_namespace.type_hash[hash_ident(name)]; cur; cur = cur->next) {
    if(cur->t == t && !strcmp(cur->name, name))
      return cur->type;
  }
  return NULL;
}

static type_t *find_type_or_error(const char *name, int t)
{
  type_t *type = find_type(name, NULL, t);
  if (!type) {
    error_loc("type '%s' not found\n", name);
    return NULL;
  }
  return type;
}

static type_t *find_type_or_error2(char *name, int t)
{
  type_t *tp = find_type_or_error(name, t);
  free(name);
  return tp;
}

int is_type(const char *name)
{
  return find_type(name, current_namespace, 0) != NULL;
}

type_t *get_type(enum type_type type, char *name, struct namespace *namespace, int t)
{
  type_t *tp;
  if (!namespace)
    namespace = &global_namespace;
  if (name) {
    tp = find_type(name, namespace, t);
    if (tp) {
      free(name);
      return tp;
    }
  }
  tp = make_type(type);
  tp->name = name;
  tp->namespace = namespace;
  if (!name) return tp;
  return reg_type(tp, name, namespace, t);
}

/***** constant repository *****/

struct rconst {
  char *name;
  var_t *var;
  struct rconst *next;
};

struct rconst *const_hash[HASHMAX];

static var_t *reg_const(var_t *var)
{
  struct rconst *nc;
  int hash;
  if (!var->name) {
    error_loc("registering constant without name\n");
    return var;
  }
  hash = hash_ident(var->name);
  nc = xmalloc(sizeof(struct rconst));
  nc->name = var->name;
  nc->var = var;
  nc->next = const_hash[hash];
  const_hash[hash] = nc;
  return var;
}

var_t *find_const(const char *name, int f)
{
  struct rconst *cur = const_hash[hash_ident(name)];
  while (cur && strcmp(cur->name, name))
    cur = cur->next;
  if (!cur) {
    if (f) error_loc("constant '%s' not found\n", name);
    return NULL;
  }
  return cur->var;
}

static char *gen_name(void)
{
  static const char format[] = "__WIDL_%s_generated_name_%08lX";
  static unsigned long n = 0;
  static const char *file_id;
  static size_t size;
  char *name;

  if (! file_id)
  {
    char *dst = dup_basename(input_idl_name, ".idl");
    file_id = dst;

    for (; *dst; ++dst)
      if (! isalnum((unsigned char) *dst))
        *dst = '_';

    size = sizeof format - 7 + strlen(file_id) + 8;
  }

  name = xmalloc(size);
  sprintf(name, format, file_id, n++);
  return name;
}

struct allowed_attr
{
    unsigned int dce_compatible : 1;
    unsigned int acf : 1;
    unsigned int on_interface : 1;
    unsigned int on_function : 1;
    unsigned int on_arg : 1;
    unsigned int on_type : 1;
    unsigned int on_enum : 1;
    unsigned int on_struct : 2;
    unsigned int on_union : 1;
    unsigned int on_field : 1;
    unsigned int on_library : 1;
    unsigned int on_dispinterface : 1;
    unsigned int on_module : 1;
    unsigned int on_coclass : 1;
    const char *display_name;
};

struct allowed_attr allowed_attr[] =
{
    /* attr                        { D ACF I Fn ARG T En St Un Fi  L  DI M  C  <display name> } */
    /* ATTR_AGGREGATABLE */        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "aggregatable" },
    /* ATTR_ANNOTATION */          { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "annotation" },
    /* ATTR_APPOBJECT */           { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "appobject" },
    /* ATTR_ASYNC */               { 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "async" },
    /* ATTR_ASYNCUUID */           { 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, "async_uuid" },
    /* ATTR_AUTO_HANDLE */         { 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "auto_handle" },
    /* ATTR_BINDABLE */            { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "bindable" },
    /* ATTR_BROADCAST */           { 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "broadcast" },
    /* ATTR_CALLAS */              { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "call_as" },
    /* ATTR_CALLCONV */            { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL },
    /* ATTR_CASE */                { 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "case" },
    /* ATTR_CODE */                { 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "code" },
    /* ATTR_COMMSTATUS */          { 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "comm_status" },
    /* ATTR_CONST */               { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "const" },
    /* ATTR_CONTEXTHANDLE */       { 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "context_handle" },
    /* ATTR_CONTROL */             { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, "control" },
    /* ATTR_DECODE */              { 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "decode" },
    /* ATTR_DEFAULT */             { 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, "default" },
    /* ATTR_DEFAULTBIND */         { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultbind" },
    /* ATTR_DEFAULTCOLLELEM */     { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultcollelem" },
    /* ATTR_DEFAULTVALUE */        { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultvalue" },
    /* ATTR_DEFAULTVTABLE */       { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "defaultvtable" },
 /* ATTR_DISABLECONSISTENCYCHECK */{ 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "disable_consistency_check" },
    /* ATTR_DISPINTERFACE */       { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL },
    /* ATTR_DISPLAYBIND */         { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "displaybind" },
    /* ATTR_DLLNAME */             { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, "dllname" },
    /* ATTR_DUAL */                { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "dual" },
    /* ATTR_ENABLEALLOCATE */      { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "enable_allocate" },
    /* ATTR_ENCODE */              { 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "encode" },
    /* ATTR_ENDPOINT */            { 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "endpoint" },
    /* ATTR_ENTRY */               { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "entry" },
    /* ATTR_EXPLICIT_HANDLE */     { 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "explicit_handle" },
    /* ATTR_FAULTSTATUS */         { 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "fault_status" },
    /* ATTR_FORCEALLOCATE */       { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "force_allocate" },
    /* ATTR_HANDLE */              { 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "handle" },
    /* ATTR_HELPCONTEXT */         { 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, "helpcontext" },
    /* ATTR_HELPFILE */            { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "helpfile" },
    /* ATTR_HELPSTRING */          { 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, "helpstring" },
    /* ATTR_HELPSTRINGCONTEXT */   { 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, "helpstringcontext" },
    /* ATTR_HELPSTRINGDLL */       { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "helpstringdll" },
    /* ATTR_HIDDEN */              { 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, "hidden" },
    /* ATTR_ID */                  { 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, "id" },
    /* ATTR_IDEMPOTENT */          { 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "idempotent" },
    /* ATTR_IGNORE */              { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "ignore" },
    /* ATTR_IIDIS */               { 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "iid_is" },
    /* ATTR_IMMEDIATEBIND */       { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "immediatebind" },
    /* ATTR_IMPLICIT_HANDLE */     { 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "implicit_handle" },
    /* ATTR_IN */                  { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "in" },
    /* ATTR_INLINE */              { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "inline" },
    /* ATTR_INPUTSYNC */           { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "inputsync" },
    /* ATTR_LENGTHIS */            { 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "length_is" },
    /* ATTR_LIBLCID */             { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "lcid" },
    /* ATTR_LICENSED */            { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "licensed" },
    /* ATTR_LOCAL */               { 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "local" },
    /* ATTR_MAYBE */               { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "maybe" },
    /* ATTR_MESSAGE */             { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "message" },
    /* ATTR_NOCODE */              { 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nocode" },
    /* ATTR_NONBROWSABLE */        { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nonbrowsable" },
    /* ATTR_NONCREATABLE */        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "noncreatable" },
    /* ATTR_NONEXTENSIBLE */       { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nonextensible" },
    /* ATTR_NOTIFY */              { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "notify" },
    /* ATTR_NOTIFYFLAG */          { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "notify_flag" },
    /* ATTR_OBJECT */              { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "object" },
    /* ATTR_ODL */                 { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "odl" },
    /* ATTR_OLEAUTOMATION */       { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "oleautomation" },
    /* ATTR_OPTIMIZE */            { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "optimize" },
    /* ATTR_OPTIONAL */            { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "optional" },
    /* ATTR_OUT */                 { 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "out" },
    /* ATTR_PARAMLCID */           { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "lcid" },
    /* ATTR_PARTIALIGNORE */       { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "partial_ignore" },
    /* ATTR_POINTERDEFAULT */      { 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "pointer_default" },
    /* ATTR_POINTERTYPE */         { 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, "ref, unique or ptr" },
    /* ATTR_PROGID */              { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "progid" },
    /* ATTR_PROPGET */             { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propget" },
    /* ATTR_PROPPUT */             { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propput" },
    /* ATTR_PROPPUTREF */          { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propputref" },
    /* ATTR_PROXY */               { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "proxy" },
    /* ATTR_PUBLIC */              { 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "public" },
    /* ATTR_RANGE */               { 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, "range" },
    /* ATTR_READONLY */            { 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "readonly" },
    /* ATTR_REPRESENTAS */         { 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "represent_as" },
    /* ATTR_REQUESTEDIT */         { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "requestedit" },
    /* ATTR_RESTRICTED */          { 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, "restricted" },
    /* ATTR_RETVAL */              { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "retval" },
    /* ATTR_SIZEIS */              { 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "size_is" },
    /* ATTR_SOURCE */              { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "source" },
    /* ATTR_STRICTCONTEXTHANDLE */ { 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "strict_context_handle" },
    /* ATTR_STRING */              { 1, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, "string" },
    /* ATTR_SWITCHIS */            { 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "switch_is" },
    /* ATTR_SWITCHTYPE */          { 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, "switch_type" },
    /* ATTR_THREADING */           { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "threading" },
    /* ATTR_TRANSMITAS */          { 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "transmit_as" },
    /* ATTR_UIDEFAULT */           { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "uidefault" },
    /* ATTR_USESGETLASTERROR */    { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "usesgetlasterror" },
    /* ATTR_USERMARSHAL */         { 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "user_marshal" },
    /* ATTR_UUID */                { 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, "uuid" },
    /* ATTR_V1ENUM */              { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, "v1_enum" },
    /* ATTR_VARARG */              { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "vararg" },
    /* ATTR_VERSION */             { 1, 0, 1, 0, 0, 1, 1, 2, 0, 0, 1, 0, 0, 1, "version" },
    /* ATTR_VIPROGID */            { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "vi_progid" },
    /* ATTR_WIREMARSHAL */         { 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, "wire_marshal" },
};

const char *get_attr_display_name(enum attr_type type)
{
    return allowed_attr[type].display_name;
}

static attr_list_t *check_iface_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_interface)
      error_loc("inapplicable attribute %s for interface %s\n",
                allowed_attr[attr->type].display_name, name);
    if (attr->type == ATTR_IMPLICIT_HANDLE)
    {
        const var_t *var = attr->u.pval;
        if (type_get_type( var->type) == TYPE_BASIC &&
            type_basic_get_type( var->type ) == TYPE_BASIC_HANDLE)
            continue;
        if (is_aliaschain_attr( var->type, ATTR_HANDLE ))
            continue;
      error_loc("attribute %s requires a handle type in interface %s\n",
                allowed_attr[attr->type].display_name, name);
    }
  }
  return attrs;
}

static attr_list_t *check_function_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_function)
      error_loc("inapplicable attribute %s for function %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static void check_arg_attrs(const var_t *arg)
{
  const attr_t *attr;

  if (arg->attrs)
  {
    LIST_FOR_EACH_ENTRY(attr, arg->attrs, const attr_t, entry)
    {
      if (!allowed_attr[attr->type].on_arg)
        error_loc("inapplicable attribute %s for argument %s\n",
                  allowed_attr[attr->type].display_name, arg->name);
    }
  }
}

static attr_list_t *check_typedef_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_type)
      error_loc("inapplicable attribute %s for typedef\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_enum_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_enum)
      error_loc("inapplicable attribute %s for enum\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_struct_attrs(attr_list_t *attrs)
{
  int mask = winrt_mode ? 3 : 1;
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!(allowed_attr[attr->type].on_struct & mask))
      error_loc("inapplicable attribute %s for struct\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_union_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_union)
      error_loc("inapplicable attribute %s for union\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_field_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_field)
      error_loc("inapplicable attribute %s for field %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_library_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_library)
      error_loc("inapplicable attribute %s for library %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_dispiface_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_dispinterface)
      error_loc("inapplicable attribute %s for dispinterface %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_module_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_module)
      error_loc("inapplicable attribute %s for module %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_coclass_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_coclass)
      error_loc("inapplicable attribute %s for coclass %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static int is_allowed_conf_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_HYPER:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_WCHAR:
            return TRUE;
        default:
            return FALSE;
        }
    case TYPE_ALIAS:
        /* shouldn't get here because of type_get_type call above */
        assert(0);
        /* fall through */
    case TYPE_STRUCT:
    case TYPE_UNION:
    case TYPE_ENCAPSULATED_UNION:
    case TYPE_ARRAY:
    case TYPE_POINTER:
    case TYPE_VOID:
    case TYPE_MODULE:
    case TYPE_COCLASS:
    case TYPE_FUNCTION:
    case TYPE_INTERFACE:
    case TYPE_BITFIELD:
        return FALSE;
    }
    return FALSE;
}

static int is_ptr_guid_type(const type_t *type)
{
    /* first, make sure it is a pointer to something */
    if (!is_ptr(type)) return FALSE;

    /* second, make sure it is a pointer to something of size sizeof(GUID),
     * i.e. 16 bytes */
    return (type_memsize(type_pointer_get_ref(type)) == 16);
}

static void check_conformance_expr_list(const char *attr_name, const var_t *arg, const type_t *container_type, expr_list_t *expr_list)
{
    expr_t *dim;
    struct expr_loc expr_loc;
    expr_loc.v = arg;
    expr_loc.attr = attr_name;
    if (expr_list) LIST_FOR_EACH_ENTRY(dim, expr_list, expr_t, entry)
    {
        if (dim->type != EXPR_VOID)
        {
            const type_t *expr_type = expr_resolve_type(&expr_loc, container_type, dim);
            if (!is_allowed_conf_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to integral type <= 32bits for attribute %s\n",
                               attr_name);
        }
    }
}

static void check_remoting_fields(const var_t *var, type_t *type);

/* checks that properties common to fields and arguments are consistent */
static void check_field_common(const type_t *container_type,
                               const char *container_name, const var_t *arg)
{
    type_t *type = arg->type;
    int more_to_do;
    const char *container_type_name;
    const char *var_type;

    switch (type_get_type(container_type))
    {
    case TYPE_STRUCT:
        container_type_name = "struct";
        var_type = "field";
        break;
    case TYPE_UNION:
        container_type_name = "union";
        var_type = "arm";
        break;
    case TYPE_ENCAPSULATED_UNION:
        container_type_name = "encapsulated union";
        var_type = "arm";
        break;
    case TYPE_FUNCTION:
        container_type_name = "function";
        var_type = "parameter";
        break;
    default:
        /* should be no other container types */
        assert(0);
        return;
    }

    if (is_attr(arg->attrs, ATTR_LENGTHIS) &&
        (is_attr(arg->attrs, ATTR_STRING) || is_aliaschain_attr(arg->type, ATTR_STRING)))
        error_loc_info(&arg->loc_info,
                       "string and length_is specified for argument %s are mutually exclusive attributes\n",
                       arg->name);

    if (is_attr(arg->attrs, ATTR_SIZEIS))
    {
        expr_list_t *size_is_exprs = get_attrp(arg->attrs, ATTR_SIZEIS);
        check_conformance_expr_list("size_is", arg, container_type, size_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_LENGTHIS))
    {
        expr_list_t *length_is_exprs = get_attrp(arg->attrs, ATTR_LENGTHIS);
        check_conformance_expr_list("length_is", arg, container_type, length_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_IIDIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_IIDIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "iid_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_ptr_guid_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to pointer to GUID type for attribute iid_is\n");
        }
    }
    if (is_attr(arg->attrs, ATTR_SWITCHIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_SWITCHIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "switch_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_allowed_conf_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to integral type <= 32bits for attribute %s\n",
                               expr_loc.attr);
        }
    }

    do
    {
        more_to_do = FALSE;

        switch (typegen_detect_type(type, arg->attrs, TDT_IGNORE_STRINGS))
        {
        case TGT_STRUCT:
        case TGT_UNION:
            check_remoting_fields(arg, type);
            break;
        case TGT_INVALID:
        {
            const char *reason = "is invalid";
            switch (type_get_type(type))
            {
            case TYPE_VOID:
                reason = "cannot derive from void *";
                break;
            case TYPE_FUNCTION:
                reason = "cannot be a function pointer";
                break;
            case TYPE_BITFIELD:
                reason = "cannot be a bit-field";
                break;
            case TYPE_COCLASS:
                reason = "cannot be a class";
                break;
            case TYPE_INTERFACE:
                reason = "cannot be a non-pointer to an interface";
                break;
            case TYPE_MODULE:
                reason = "cannot be a module";
                break;
            default:
                break;
            }
            error_loc_info(&arg->loc_info, "%s \'%s\' of %s \'%s\' %s\n",
                           var_type, arg->name, container_type_name, container_name, reason);
            break;
        }
        case TGT_CTXT_HANDLE:
        case TGT_CTXT_HANDLE_POINTER:
            if (type_get_type(container_type) != TYPE_FUNCTION)
                error_loc_info(&arg->loc_info,
                               "%s \'%s\' of %s \'%s\' cannot be a context handle\n",
                               var_type, arg->name, container_type_name,
                               container_name);
            break;
        case TGT_STRING:
        {
            const type_t *t = type;
            while (is_ptr(t))
                t = type_pointer_get_ref(t);
            if (is_aliaschain_attr(t, ATTR_RANGE))
                warning_loc_info(&arg->loc_info, "%s: range not verified for a string of ranged types\n", arg->name);
            break;
        }
        case TGT_POINTER:
            type = type_pointer_get_ref(type);
            more_to_do = TRUE;
            break;
        case TGT_ARRAY:
            type = type_array_get_element(type);
            more_to_do = TRUE;
            break;
        case TGT_USER_TYPE:
        case TGT_IFACE_POINTER:
        case TGT_BASIC:
        case TGT_ENUM:
        case TGT_RANGE:
            /* nothing to do */
            break;
        }
    } while (more_to_do);
}

static void check_remoting_fields(const var_t *var, type_t *type)
{
    const var_t *field;
    const var_list_t *fields = NULL;

    type = type_get_real_type(type);

    if (type->checked)
        return;

    type->checked = TRUE;

    if (type_get_type(type) == TYPE_STRUCT)
    {
        if (type_is_complete(type))
            fields = type_struct_get_fields(type);
        else
            error_loc_info(&var->loc_info, "undefined type declaration %s\n", type->name);
    }
    else if (type_get_type(type) == TYPE_UNION || type_get_type(type) == TYPE_ENCAPSULATED_UNION)
        fields = type_union_get_cases(type);

    if (fields) LIST_FOR_EACH_ENTRY( field, fields, const var_t, entry )
        if (field->type) check_field_common(type, type->name, field);
}

/* checks that arguments for a function make sense for marshalling and unmarshalling */
static void check_remoting_args(const var_t *func)
{
    const char *funcname = func->name;
    const var_t *arg;

    if (func->type->details.function->args) LIST_FOR_EACH_ENTRY( arg, func->type->details.function->args, const var_t, entry )
    {
        const type_t *type = arg->type;

        /* check that [out] parameters have enough pointer levels */
        if (is_attr(arg->attrs, ATTR_OUT))
        {
            switch (typegen_detect_type(type, arg->attrs, TDT_ALL_TYPES))
            {
            case TGT_BASIC:
            case TGT_ENUM:
            case TGT_RANGE:
            case TGT_STRUCT:
            case TGT_UNION:
            case TGT_CTXT_HANDLE:
            case TGT_USER_TYPE:
                error_loc_info(&arg->loc_info, "out parameter \'%s\' of function \'%s\' is not a pointer\n", arg->name, funcname);
                break;
            case TGT_IFACE_POINTER:
                error_loc_info(&arg->loc_info, "out interface pointer \'%s\' of function \'%s\' is not a double pointer\n", arg->name, funcname);
                break;
            case TGT_STRING:
                if (is_array(type))
                {
                    /* needs conformance or fixed dimension */
                    if (type_array_has_conformance(type) &&
                        type_array_get_conformance(type)->type != EXPR_VOID) break;
                    if (!type_array_has_conformance(type) && type_array_get_dim(type)) break;
                }
                if (is_attr( arg->attrs, ATTR_IN )) break;
                error_loc_info(&arg->loc_info, "out parameter \'%s\' of function \'%s\' cannot be an unsized string\n", arg->name, funcname);
                break;
            case TGT_INVALID:
                /* already error'd before we get here */
            case TGT_CTXT_HANDLE_POINTER:
            case TGT_POINTER:
            case TGT_ARRAY:
                /* OK */
                break;
            }
        }

        check_field_common(func->type, funcname, arg);
    }

    if (type_get_type(type_function_get_rettype(func->type)) != TYPE_VOID)
    {
        var_t var;
        var = *func;
        var.type = type_function_get_rettype(func->type);
        var.name = xstrdup("return value");
        check_field_common(func->type, funcname, &var);
        free(var.name);
    }
}

static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func)
{
    unsigned char explicit_fc, implicit_fc;

    /* check for a defined binding handle */
    if (!get_func_handle_var( iface, func, &explicit_fc, &implicit_fc ) || !explicit_fc)
    {
        /* no explicit handle specified so add
         * "[in] handle_t IDL_handle" as the first parameter to the
         * function */
        var_t *idl_handle = make_var(xstrdup("IDL_handle"));
        idl_handle->attrs = append_attr(NULL, make_attr(ATTR_IN));
        idl_handle->type = find_type_or_error("handle_t", 0);
        type_function_add_head_arg(func->type, idl_handle);
    }
}

static void check_functions(const type_t *iface, int is_inside_library)
{
    const statement_t *stmt;
    if (is_attr(iface->attrs, ATTR_EXPLICIT_HANDLE))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            var_t *func = stmt->u.var;
            add_explicit_handle_if_necessary(iface, func);
        }
    }
    if (!is_inside_library && !is_attr(iface->attrs, ATTR_LOCAL))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            const var_t *func = stmt->u.var;
            if (!is_attr(func->attrs, ATTR_LOCAL))
                check_remoting_args(func);
        }
    }
}

static void check_statements(const statement_list_t *stmts, int is_inside_library)
{
    const statement_t *stmt;

    if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
    {
        switch(stmt->type) {
        case STMT_LIBRARY:
            check_statements(stmt->u.lib->stmts, TRUE);
            break;
        case STMT_TYPE:
            switch(type_get_type(stmt->u.type)) {
            case TYPE_INTERFACE:
                check_functions(stmt->u.type, is_inside_library);
                break;
            case TYPE_COCLASS:
                if(winrt_mode)
                    error_loc("coclass is not allowed in Windows Runtime mode\n");
                break;
            default:
                break;
            }
            break;
        default:
            break;
        }
    }
}

static void check_all_user_types(const statement_list_t *stmts)
{
  const statement_t *stmt;

  if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
  {
    if (stmt->type == STMT_LIBRARY)
      check_all_user_types(stmt->u.lib->stmts);
    else if (stmt->type == STMT_TYPE && type_get_type(stmt->u.type) == TYPE_INTERFACE &&
             !is_local(stmt->u.type->attrs))
    {
      const statement_t *stmt_func;
      STATEMENTS_FOR_EACH_FUNC(stmt_func, type_iface_get_stmts(stmt->u.type)) {
        const var_t *func = stmt_func->u.var;
        check_for_additional_prototype_types(func->type->details.function->args);
      }
    }
  }
}

int is_valid_uuid(const char *s)
{
  int i;

  for (i = 0; i < 36; ++i)
    if (i == 8 || i == 13 || i == 18 || i == 23)
    {
      if (s[i] != '-')
        return FALSE;
    }
    else
      if (!isxdigit(s[i]))
        return FALSE;

  return s[i] == '\0';
}

static statement_t *make_statement(enum statement_type type)
{
    statement_t *stmt = xmalloc(sizeof(*stmt));
    stmt->type = type;
    return stmt;
}

static statement_t *make_statement_type_decl(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPE);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_reference(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPEREF);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_declaration(var_t *var)
{
    statement_t *stmt = make_statement(STMT_DECLARATION);
    stmt->u.var = var;
    if (var->stgclass == STG_EXTERN && var->eval)
        warning("'%s' initialised and declared extern\n", var->name);
    if (is_const_decl(var))
    {
        if (var->eval)
            reg_const(var);
    }
    else if (type_get_type(var->type) == TYPE_FUNCTION)
        check_function_attrs(var->name, var->attrs);
    else if (var->stgclass == STG_NONE || var->stgclass == STG_REGISTER)
        error_loc("instantiation of data is illegal\n");
    return stmt;
}

static statement_t *make_statement_library(typelib_t *typelib)
{
    statement_t *stmt = make_statement(STMT_LIBRARY);
    stmt->u.lib = typelib;
    return stmt;
}

static statement_t *make_statement_pragma(const char *str)
{
    statement_t *stmt = make_statement(STMT_PRAGMA);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_cppquote(const char *str)
{
    statement_t *stmt = make_statement(STMT_CPPQUOTE);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_importlib(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORTLIB);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_import(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORT);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_module(type_t *type)
{
    statement_t *stmt = make_statement(STMT_MODULE);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_typedef(declarator_list_t *decls)
{
    declarator_t *decl, *next;
    statement_t *stmt;
    type_list_t **type_list;

    if (!decls) return NULL;

    stmt = make_statement(STMT_TYPEDEF);
    stmt->u.type_list = NULL;
    type_list = &stmt->u.type_list;

    LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
    {
        var_t *var = decl->var;
        type_t *type = find_type_or_error(var->name, 0);
        *type_list = xmalloc(sizeof(type_list_t));
        (*type_list)->type = type;
        (*type_list)->next = NULL;

        type_list = &(*type_list)->next;
        free(decl);
        free(var);
    }

    return stmt;
}

static statement_list_t *append_statements(statement_list_t *l1, statement_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static attr_list_t *append_attribs(attr_list_t *l1, attr_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt)
{
    if (!stmt) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &stmt->entry );
    return list;
}

void init_loc_info(loc_info_t *i)
{
    i->input_name = input_name ? input_name : "stdin";
    i->line_number = line_number;
    i->near_text = parser_text;
}

static void check_def(const type_t *t)
{
    if (t->defined)
        error_loc("%s: redefinition error; original definition was at %s:%d\n",
                  t->name, t->loc_info.input_name, t->loc_info.line_number);
}

